namespace mylib{
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;
using System;
using mylib;
#if MDX || GAMEPAD
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using DirectX=Microsoft.DirectX;
using Direct3D=Microsoft.DirectX.Direct3D;
#endif

// MDXɊւĂ͌
//
//

class WinMain : Form{
	private GamePad gamePad;

	private EnvManager env;
	
	private bool cpuLock=true;

	private Timer gameTimer;

	private string codeBase = System.AppDomain.CurrentDomain.BaseDirectory;
	private string webCodeBase ="http://www.janis.or.jp/users/segabito/";

	private bool isDisposing=false;
	private bool isDisposed=false;

#if MDX || GAMEPAD
	private JoyPad joyPad=null;
	private Microsoft.DirectX.Direct3D.Device device=null;
#endif


	private static string[] argv;
	public static void Main(string[] args){
		argv=args;
		Console.WriteLine("Maryo World!");

		WinMain win = new WinMain();
		win.Text="\"SUPER MARYO WORLD\" - .NET Framework";
		Application.Run(win);
	}

	private Graphics formGraphics;
	public WinMain(){
		ClientSize = new Size(400,300);

#if MDX
		ClientSize = new Size(640,480);
//		 ClientSize = new Size(512,448);
//		 ClientSize = new Size(320,240);
		initMDX( ( argv.Length > 0 ) );
#endif
		
		try{
		 if(codeBase.IndexOf("http://")>=0){
			//m[^b`fvCg[h
			
		 }else{
			//[Jł̎s
		
			if(!System.IO.File.Exists("stage0.txt")){
				Console.WriteLine("f[^t@CȂ߁AWebǂݍ݂܂");
				codeBase=webCodeBase;
			}


		//	܂Ȃ
		//	bool b=MDXcheck.check();
		//	Console.WriteLine("MDXcheck="+b);
		//	if(b){
#if MDX || GAMEPAD
			joyPad = new DXJoyPad(this);
			Console.WriteLine("Joypad="+joyPad.Enabled);
#endif
		//	}
		 }
		}catch(System.IO.FileNotFoundException fe){
			Console.WriteLine("WinMain:FileNotFoundException"+fe);
		}
		catch(Exception e){
			Console.WriteLine("WinMain:Exception"+e);
		}

		formGraphics=CreateGraphics();
		formGraphics.SmoothingMode = SmoothingMode.None;
		formGraphics.InterpolationMode = InterpolationMode.NearestNeighbor;
		this.SetStyle(ControlStyles.DoubleBuffer, true);
		this.SetStyle(ControlStyles.UserPaint, true);
		this.SetStyle(ControlStyles.AllPaintingInWmPaint, true);


		initEnv(gamePad);
		env.Start();



		gameTimer = new Timer();
		gameTimer.Tick += new EventHandler(GameTimerEvent);
		gameTimer.Interval=30;
		gameTimer.Start();

		GotFocus  += new EventHandler(OnFocus);
		LostFocus += new EventHandler(OnBlur);


		cpuLock=false;
	}
	private void initEnv(GamePad gp){

#if MDX
		env=new EnvManager(codeBase,ClientRectangle.Width,ClientRectangle.Width*3/4,device);
#else
		env=new EnvManager(codeBase,ClientRectangle.Width,ClientRectangle.Width*3/4);
#endif
		gamePad=env.GetGamePad();

		env.SetVirtualScreenSize(512,448);

		env.SetGameFont(
			new System.Drawing.Font("Impact", (float)(env.ScreenHeight/18),FontStyle.Bold),
			Color.White
		);
		env.SetScoreFont(
			new System.Drawing.Font("lr SVbN", (float)(env.ScreenHeight/30),FontStyle.Bold),
			Color.White
		);
		env.SetInfoFont(
			new System.Drawing.Font("lr ",(float)(env.ScreenHeight/12),FontStyle.Bold),
			Color.White
		);
		
		Player P=env.GetPlayerObject();
		P.PlayerDamage += new PlayerDamageHandler(this.OnPlayerDamage);

	}

	
	



	private void action(){
		if(cpuLock)return;
		cpuLock=true;
		 joyCheck();
		 env.Action();
		 env.Scroll();
		 env.Draw();
		cpuLock=false;
	}
	private void joyCheck(){
#if MDX
		if(joyPad==null)return;
		if(joyPad.Enabled){
			joyPad.GetData();
			gamePad.ButtonA=joyPad.ButtonA;
			gamePad.ButtonB=joyPad.ButtonB;
			gamePad.X=joyPad.X;
			gamePad.Y=joyPad.Y;
		}
#endif
	}


	private void OnPlayerDamage(int damage,MCharacter m){
#if MDX
 // ԂԂH
 	if(joyPad.Enabled){
	}
#endif
		env.DBGn("damage!");
	}


	private void draw(Graphics g){
	 if(cpuLock)return;

		int dw=ClientRectangle.Width;
		int dh=ClientRectangle.Height;
		double ix = ((double)dw)/env.VirtualWidth;
		double iy = ((double)dh)/env.VirtualHeight;
		if(ix<iy)dh=(int)System.Math.Round(ix*env.VirtualHeight);
		else	 dw=(int)System.Math.Round(iy*env.VirtualWidth);

		int ctx=(ClientRectangle.Width  - dw) / 2;
		int cty=(ClientRectangle.Height - dh) / 2;

		env.BufferToScreen(g,ctx,cty,dw,dh);
	}
	


//------------------------------

	private void GameTimerEvent(object obj,EventArgs e){
#if MDX
		if(device.Disposed)return;
		device.ShowCursor(!fullscreen);
		if(fullscreen)Cursor.Hide();
		else Cursor.Show();
#endif
		action();
		draw(formGraphics);
	}

	override protected void OnPaint(PaintEventArgs e){
		return;
	}
	protected void OnFocus(object o,EventArgs e){
		Console.WriteLine("get focus");

#if MDX
	if(lostflag){
		if(initMDX(fullscreen))lostflag=false;
	}
#endif
	}
	protected void OnBlur(object o,EventArgs e){
		Console.WriteLine("lost focus");
		if(cpuLock)return;
		env.Pause(true);
	}


	override protected void OnResize(System.EventArgs e){
		if(formGraphics!=null)formGraphics.Dispose();
		formGraphics=CreateGraphics();
		formGraphics.SmoothingMode = SmoothingMode.None;
		formGraphics.InterpolationMode = InterpolationMode.NearestNeighbor;
		formGraphics.Clear(BackColor);
		
	}
	

	override protected void OnKeyDown(KeyEventArgs e)
	{
		int kv=e.KeyValue %256;
		switch(kv){
			case (int)Keys.Left:
			 gamePad.X=-1;
			break;
			case (int)Keys.Right:
			 gamePad.X= 1;
			break;
			case (int)Keys.Up:
			 gamePad.Y=-1;
			break;
			case (int)Keys.Down:
			 gamePad.Y= 1;
			break;


			case (int)Keys.ShiftKey:
			 gamePad.ButtonA=1;
			break;
			case (int)Keys.Space:
			 gamePad.ButtonA=1;
			break;
			case (int)Keys.X:
			 gamePad.ButtonA=1;
			break;


			case (int)Keys.ControlKey:
			 gamePad.ButtonB=1;
			break;
			case (int)Keys.Z:
			 gamePad.ButtonB=1;
			break;
			case (int)Keys.C:
			 gamePad.ButtonB=1;
			break;

		}
	}

	override protected void OnKeyUp(KeyEventArgs e)
	{
		int kv=e.KeyValue %256;
		switch(kv){
			case (int)Keys.Left:
			 gamePad.X = 0;
			break;
			case (int)Keys.Right:
			 gamePad.X = 0;
			break;
			case (int)Keys.Up:
			 gamePad.Y =-0;
			break;
			case (int)Keys.Down:
			 gamePad.Y = 0;
			break;


			case (int)Keys.ShiftKey:
			 gamePad.ButtonA=0;
			break;
			case (int)Keys.Space:
			 gamePad.ButtonA=0;
			break;
			case (int)Keys.X:
			 gamePad.ButtonA=0;
			break;


			case (int)Keys.ControlKey:
			 gamePad.ButtonB=0;
			break;
			case (int)Keys.Z:
			 gamePad.ButtonB=0;
			break;
			case (int)Keys.C:
			 gamePad.ButtonB=0;
			break;
			
			case (int)Keys.Escape:
			 env.Pause();
			 env.DBGn("Pause!");
			break;

			case (int)Keys.M:
			{
			 Graphics gg=env.GetGraphics();
			 switch(gg.InterpolationMode){
				case InterpolationMode.Bilinear:
					gg.InterpolationMode=InterpolationMode.NearestNeighbor;
				break;
				case InterpolationMode.NearestNeighbor:
					gg.InterpolationMode=InterpolationMode.Bicubic;
				break;
				case InterpolationMode.Bicubic:
					gg.InterpolationMode=InterpolationMode.HighQualityBicubic;
				break;
				case InterpolationMode.HighQualityBicubic:
					gg.InterpolationMode=InterpolationMode.Bilinear;
				break;
			 }
			 env.CenterMessage(""+gg.InterpolationMode,100,100).YMove=-1;
			}
			break;

			case (int)Keys.Delete:
			{
			 if(env.Mode==EnvManager.Gaming){
			  Player P=env.GetPlayerObject();
			   P.Damage(null);
			 }
			}
			break;

#if mytest || MDX
			case (int)Keys.P:
			{
			 Player P=env.GetPlayerObject();
			 env.DBGn(" Player x="+P.X+" y="+P.Y);
			}
			break;

			case (int)Keys.L:
			{
			 Player P=env.GetPlayerObject();
			 if(env.Mode==EnvManager.Gaming){
			 env.SetXYPointObject(P.X,P.Y,Blocks.Goal);
			 env.SetXYPointObject(P.X+env.BlockWidth,P.Y,Blocks.Goal);
			 }
			}
			break;
			case (int)Keys.O:
			{
			 Player P=env.GetPlayerObject();
			 P.Axe();
			}
			break;

			case (int)Keys.I:
			{
			 Player P=env.GetPlayerObject();
			 P.GetItem(ItemCode.Flower);
			}
			break;


			case (int)Keys.U:
			{
			 Player P=env.GetPlayerObject();
			 P.GetItem(ItemCode.Iget);
			}
			break;


			case (int)Keys.F:
			{
			 Player P=env.GetPlayerObject();
			 P.ActionMode=ActionMode.Fly;
			 env.CreateMessage("I can fly!",P.X+P.Width,P.Y);
			}
			break;

			case (int)Keys.R:
			{
			 Player P=env.GetPlayerObject();
			 P.ActionMode=ActionMode.Run;
			}
			break;

			case (int)Keys.T:
			{
				env.Mozaic=50;
			}
			break;
#endif

#if MDX

			case (int)Keys.Enter:
			 initMDX(!fullscreen);
			break;

#endif

		}
	}//

	
	protected override void Dispose(bool disposing){
		isDisposing=true;
		cpuLock=true;
		if(!isDisposed){
		 gameTimer.Stop();
		 env.Dispose();
#if MDX
		 if(device!=null)device.Dispose();
#endif
		}
		base.Dispose(disposing);
		isDisposed=true;
	}//


#if MDX
	private bool fullscreen=false;
	private EventHandler onLost;
	private EventHandler onReset;
	
	private bool initMDX(bool f){
		fullscreen=f;
		this.Text="\"SUPER MARYO WORLD\" - .NET Framework + Managed DirectX";
		 PresentParameters pp = new PresentParameters();
		 pp.SwapEffect = SwapEffect.Discard;
		 pp.BackBufferCount = 1;


//		GraphicsgpȂRgO
//		 pp.PresentFlag = PresentFlag.LockableBackBuffer;

		 ClientSize = new Size(640,480);
		if(fullscreen){
		 this.FormBorderStyle = FormBorderStyle.None;
		 pp.Windowed = false;
		 pp.BackBufferFormat = Format.R5G6B5;//Format.X8R8G8B8;
		 pp.BackBufferWidth = 640;
		 pp.BackBufferHeight = 480;
		 this.TopMost = true;
		}else{
		 pp.Windowed = true;
//		 pp.BackBufferWidth = ClientRectangle.Width;
//		 pp.BackBufferHeight = ClientRectangle.Height;
		 pp.BackBufferWidth = 640;
		 pp.BackBufferHeight = 480;
		 pp.BackBufferFormat = Format.Unknown;
		 this.TopMost = false;

		}


		if(onLost ==null)onLost =new EventHandler(this.onLostDevice);
		if(onReset==null)onReset=new EventHandler(this.onResetDevice);

		if(device!=null){
//			device.DeviceLost  -= onLost;
//			device.DeviceReset -= onReset;
//			device.Dispose();
//			device=null;
		}
	  try{
		if(device==null){
		 Console.WriteLine("Create Direct3D.Device");
		 device = new Direct3D.Device(0,DeviceType.Hardware,this,
		               CreateFlags.SoftwareVertexProcessing,pp);

		
		 device.DeviceLost  += onLost;
		 device.DeviceReset += onReset;
		}else{
		 device.Reset(pp);
		 if(env!=null)env.ResetDevice(device);
		 if(!fullscreen)this.FormBorderStyle = FormBorderStyle.Sizable;
		}
	  }catch(Exception e){
		Console.WriteLine("Exception:initMDX:"+e);
		return false;
	  }
		return true;
	}
	
	private bool lostflag=false;
	private void onLostDevice(object o,EventArgs e){
		if(cpuLock)return;
		if(isDisposing)return;
		if(o==null)return;
		cpuLock=true;
		gameTimer.Stop();
		Console.WriteLine("Device Lost:"+o+":"+e);
		lostflag=true;
	}
	private void onResetDevice(object o,EventArgs e){
		if(isDisposing)return;
		if(o!=null){
//		 Device dev = o as Device;
		 Console.WriteLine("Device Reset:"+o+":"+e);
		 if(device==null){
//			Console.WriteLine("replace device");
//			device=dev;
		 }
//		 initMDX(fullscreen);
		 cpuLock=false;
		 gameTimer.Start();
		}
	}
#endif
	
} //


}