
namespace mylib
{
	using System;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;
	using Microsoft.DirectX.DirectInput;
	using Microsoft.DirectX;

	public interface JoyPad
	{
		int X{get;}
		int Y{get;}
		int ButtonA{get;}
		int ButtonB{get;}
		bool Changed{get;}
		bool Enabled{get;}
		void GetData();
	}

	public class NullPad:JoyPad
	{
		public int X{get{return 0;}}
		public int Y{get{return 0;}}
		public int ButtonA{get{return 0;}}
		public int ButtonB{get{return 0;}}
		public bool Changed{get{return false;}}
		public bool Enabled{get{return false;}}	
		public void GetData(){}
	} //

	public class MDXcheck{
		public static bool check(){
			Console.Write("MDXcheck:");
			try
			{
			//	int i=System.Runtime.InteropServices.Marshal.SizeOf(
			//							Microsoft.DirectX.Matrix.Zero);
				//Microsoft.DirectX.MatrixStack ms = new MatrixStack();
				//object i = new object();
				//object o = ms as Microsoft.DirectX.MatrixStack;
				object o = new object();
				if(o is Microsoft.DirectX.MatrixStack){
				}
			}
			catch
			{
				Console.WriteLine("error:  ");
				return false;
			}
			Console.WriteLine("OK");
			return true;
		}
	}
	public class DXJoyPad:JoyPad
	{

		private static JoystickState state = new JoystickState();
		private Device applicationDevice = null;
		private static int numPOVs = 0;


		private int[] buttons = new int[100];
		private int x=0;
		private int y=0;

		public int X
		{
			get
			{
				if(Math.Abs(x)<=100)return 0;
				return (x>0)?1:-1;
			}
		}
		public int Y
		{
			get
			{
				if(Math.Abs(y)<=100)return 0;
				return (y>0)?1:-1;
			}
		}
		public int ButtonA
		{
			get
			{
				if(buttons[1]!=0 || buttons[3]!=0 || buttons[5]!=0)
				{
					return 1;
				}
				else
					return 0;
			}
		}
		public int ButtonB
		{
			get
			{
				if(buttons[0]!=0 || buttons[2]!=0 || buttons[4]!=0)
				{
					return 1;
				}
				else
					return 0;
			}
		}
		
		private bool changed=false;
		public bool Changed
		{
			get{return changed;}
		}

		private bool enabled=false;
		public bool Enabled
		{
			get{return enabled;}
		}

		public DXJoyPad(Form f)
		{

			try
			{
				enabled=InitDirectInput(f);
			}
			catch(Exception e)
			{
				Console.WriteLine("DXJoyPad:Exception"+e);
				enabled=false;
			}
		}
/*
		~DXJoyPad()
		{
			if (null != applicationDevice)
				applicationDevice.Unacquire();
		}
*/
		public bool InitDirectInput(Form f)
		{
			foreach (DeviceInstance instance in Manager.GetDevices(DeviceClass.GameControl, EnumDevicesFlags.AttachedOnly))
			{
				applicationDevice = new Device(instance.InstanceGuid);
				break;
			}

			if (null == applicationDevice)
			{
			//	MessageBox.Show("Unable to create a joystick device. Sample will exit.", "No joystick found");
				return false;
			}

			// Set the data format to the c_dfDIJoystick pre-defined format.
			applicationDevice.SetDataFormat(DeviceDataFormat.Joystick);
			// Set the cooperative level for the device.
			applicationDevice.SetCooperativeLevel(f, CooperativeLevelFlags.Exclusive | CooperativeLevelFlags.Foreground);
			// Enumerate all the objects on the device.
			foreach (DeviceObjectInstance d in applicationDevice.Objects)
			{
				// For axes that are returned, set the DIPROP_RANGE property for the
				// enumerated axis in order to scale min/max values.

				if ((0 != (d.ObjectId & (int)DeviceObjectTypeFlags.Axis)))
				{
					// Set the range for the axis.
					applicationDevice.Properties.SetRange(ParameterHow.ById, d.ObjectId, new InputRange(-1000, +1000));
				}
			}
			return true;
		}

		public void GetData()
		{
			if (null == applicationDevice)return;

			try
			{	applicationDevice.Poll();}
			catch(InputException inputex)
			{
				if ((inputex is NotAcquiredException) || (inputex is InputLostException))
				{
					try
					{
						applicationDevice.Acquire();
					}
					catch(InputException)
					{
						return;
					}
				}
                
			} //catch(InputException inputex)

			try {state = applicationDevice.CurrentJoystickState;}
			catch(InputException)
			{
				return;
			}
			
			updateStatus();
		}
		private void updateStatus()
		{
			x=state.X;
			y=state.Y;

			int[] pov = state.GetPointOfView();

			byte[] bt = state.GetButtons();
			int button = 0;
			for(int i=0;i<bt.Length;i++)
			{
				if(i>=buttons.Length)break;
				buttons[i]=bt[i];
			}
			/*
			foreach (byte b in buttons)
			{
				if (0 != (b & 0x80))
					strText += button.ToString("00 ");
				button++;
			}
			*/
		}

		private void tick(object sender, System.EventArgs e)
		{
			//    GetData();
		}
	}



}
