namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	public class BackgroundObject: MCharacter{
		protected bool scroll=false;
		 public bool Scroll{
			get{return scroll;}
			set{scroll=value;}
		 }
		protected bool zoom=false;
		 public bool Zoom{
			get{return zoom;}
			set{Zoom=value;}
		 }
//		private double xsMove=0;
//		private double ysMove=0;
		protected double baseX=0;
		protected double baseY=0;
	
		protected double scrollZ=0;

		public BackgroundObject(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
			mind=Mind.Other;
			x=Math.Floor(xx / manager.BlockWidth ) * manager.BlockWidth;
			y=Math.Floor(yy / manager.BlockHeight) * manager.BlockHeight;
			z=99.9;
			charSpriteWidth  = (int)Math.Floor(manager.BlockWidth);
			charSpriteHeight = (int)Math.Floor(manager.BlockHeight);
			charBodyWidth  = charSpriteWidth;
			charBodyHeight = charSpriteHeight;
			xMove=0;
			yMove=0;
			xAccel=0;
			yAccel=0;

			baseX=x;
			baseY=y;
			init(xx,yy,option);
		}


		protected override void init(double xx,double yy,int option){
		

		}

	//----------------------
		public override bool Action(){
			 innerTimer++;
			 //if(manager.CheckScreen(this)<0){return false;}
			 xMove+=xAccel;
			 yMove+=yAccel;
			  baseX+=xMove;
			  baseY+=yMove;
			Face=imgWalk;
			
			 x=baseX;
			 y=baseY;

//			manager.DBG(". "+x+" "+y+"\n");

			 double sz=Zindex.StageZ;
			  if(scroll){
				x+=manager.ScrollLeft*(sz-z)/sz;
				y+=manager.ScrollTop *(sz-z)/sz;
			  }

			  return true;
		}
		public void SetBitmap(string src,int w,int h,double zz){
			imgWalk=manager.GetImageID(src);
			Face=imgWalk;

			 if(zoom){
				double zm=zz/((double)Zindex.StageZ);
				charSpriteWidth  = (int)Math.Round(w*zm);
				charSpriteHeight = (int)Math.Round(h*zm);
			 }else{
				charSpriteWidth=w;
				charSpriteHeight=h;
			 }
			charBodyWidth=w;
			charBodyHeight=h;
			 SetSize();
			Z=zz;
			Visible=true;
		
		}
		public override void MoveTo(double xx,double yy){
			baseX=xx;
			baseY=yy;
			sprite.MoveTo(x,y);
		}
		public override void MoveBy(double xx,double yy){
			baseX+=x;
			baseY+=y;
			sprite.MoveTo(x,y);
		}
		
		
		public override bool DrawEntry(){
			if(manager.CheckScreen(this)<0)return false;
			else
			return base.DrawEntry();
		}



	}









	class Castle : BackgroundObject{
		private Sprite gate;
		private Sprite wall;
		private String img;
		private String img2;
		private String img3;
		public Castle(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			double w;
			double h;
			double ew=manager.BlockWidth;
			double eh=manager.BlockHeight;
			if(charCode==mylib.CharCode.Castle){
			 w=ew*5;
			 h=eh*6;
			 img  = "img/castle.gif";
			 img2 = "img/castlegate.gif";
			}else{
			 w = ew*9;
			 h = eh*12;
			 img  = "img/bigcastle.gif";
			 img2 = "img/castlegate.gif";
			 img3 = "img/castlewall.gif";
			}
		  if(x>manager.VirtualWidth){// EXN[Oɂ蔲
			manager.SetXYPointObject(x+ew,y,Blocks.Goal,WriteMode.Ram);
			manager.SetXYPointObject(x+ew,y,Blocks.Goal,WriteMode.Ram);

			gate=new Sprite(x,y-eh,Zindex.PlayerZ+2);
			 gate.BitmapImageName=img2;
			 gate.SetSize(ew*2,eh*2);
			 gate.Visible=true;
			 //gate.Opacity=.4;
			if(charCode==mylib.CharCode.Castle){
				manager.SetCastleFlag(x,y-(h-manager.BlockHeight*2),true);
			}else{
			  wall= new Sprite(x+ew*4,y-eh*5.5+1,Zindex.StageZ);
			  wall.BitmapImageName=img3;
			  wall.SetSize(ew*10,eh*6.5+1);
			  wall.Visible=true;
			  
			}
		 }
			x=x-w/2+ew/2;
			y=y-h+eh;
			baseX=x;
			baseY=y;
			SetBitmap(img,(int)Math.Round(w),(int)Math.Round(h),Zindex.StageZ);
		}
		
		public override bool DrawEntry(){
			if(manager.CheckScreen(this)<0)return false;
			if(gate!=null)gate.DrawEntry();
			if(wall!=null)wall.DrawEntry();
			return base.DrawEntry();
		}

		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
			manager.RescuePrincess();
			if(gate!=null)gate.Kill();
			if(wall!=null)wall.Kill();
			return base.Kill(KillMode.Other);
		}

	} //






class Princess : BackgroundObject{
	private Font f;

		public Princess(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){


		  f=new Font("lr SVbN", (float)(manager.ScreenHeight/20),FontStyle.Bold);

			 int world=manager.GetWorldNumber();
			 int w=32,h=48;
			 string img="img/hiroyuko.gif";

			switch(world){
			 case 0: goto case 8;
			 case 1: goto case 8;
			 case 8:
			  img="img/pinch.gif";
			 break;
			 case 6:
			  img="img/lynch.gif";
			 break;
			}

			 SetBitmap(img,w,h,Zindex.BasicZ);
			 MoveTo(x,y-(h-manager.BlockHeight));

			 manager.SetPrincess(this);
	}

		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
			manager.RescuePrincess();
			f=null;
			return base.Kill(KillMode.Other);
		}
	
		public void ShowMessage(){
			int world=manager.GetWorldNumber();
			double vHeight=manager.VirtualHeight;
		 switch(world){
			case 0:goto case 1;
			case 1:
			 manager.CenterMessage("ɂ񂬂傤 s`Ђ߂",
							vHeight*.4,300,f).YMove=-1;
			 manager.CenterMessage("ق̂̂Ђ߂ @",
							vHeight*.6,300,f).YMove=-1;
			break;
			case 2:
			 manager.CenterMessage("ւ񂶂ȂB@@@@@@",
						vHeight*.4,300,f).YMove=-1;
			 manager.CenterMessage("̂ɂ񂬂傤̂悤B",
						vHeight*.6,300,f).YMove=-1;
			break;
			case 3:
			 manager.CenterMessage("݂̂Ȃł邵イȂ",
						vHeight*.4,300,f).YMove=-1;
			break;
			case 4:
			 manager.CenterMessage("Q[}[@qRfX",
						vHeight*.4,300,f).YMove=-1;
			 manager.CenterMessage("IeK~@@AKgE",
						vHeight*.6,300,f).YMove=-1;
			break;
			case 5:
			 manager.CenterMessage("̓J]Êł",
						vHeight*.4,300,f).YMove=-1;
			break;
			case 6:
			 manager.CenterMessage(">>s`Ђ߂̕łB@@",
						vHeight*.4,300,f).YMove=-1;
			break;
			case 7:
			 manager.CenterMessage("͂イ J ꂽI",
						vHeight*.4,300,f).YMove=-1;
			 manager.CenterMessage("R}hH@@@@@@@@@@",
						vHeight*.6,300,f).YMove=-1;
			break;

	//		case 8:
			default:
			 manager.CenterMessage("炢@@@@@@@@@",
						vHeight*.4,300,f).YMove=-1;
			break;
		  }
		 } //
		}

















}