namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	public class BalanceLift: MCharacter{
		private int imgWire;
		private int imgArm;
		private double charWireWidth;
		private double charWireHeight;
		private int wireLength;
		private Lift LL,RR;
		private Sprite l,r;
		private bool active;

		public BalanceLift(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			active=true;


			imgWalk=getImageID(EnemyParameter.BalanceLift_imgArm);
			imgArm=imgWalk;
			imgWire=getImageID(EnemyParameter.BalanceLift_imgWire);
			Face=imgWalk;

			score=1000;

			charBodyWidth  = (int)Math.Round(manager.BlockWidth);
			charBodyHeight = (int)Math.Round(manager.BlockHeight);
			charSpriteWidth  = charBodyWidth*6;
			charSpriteHeight = charBodyHeight;

			wireLength=charBodyHeight*12;
			charWireWidth  = 32; //OtBbÑTCY
			charWireHeight = wireLength/2;


			x=Math.Floor( x / manager.BlockWidth  ) * manager.BlockWidth-manager.BlockWidth*.5;
			y=Math.Floor( y / manager.BlockHeight ) * manager.BlockHeight;

			sprite.MoveTo(x-charBodyWidth*3,y+2);
			Z=Zindex.StageZ-1;
			Visible=true;


			double bw=manager.BlockWidth;
			double lw=(EnemyParameter.Lift_liftWidth-manager.BlockWidth)*.5;
			LL=(Lift)manager.CreateObject(mylib.CharCode.LiftFall,x-bw*2.5-lw,y+wireLength*.5,0);
			RR=(Lift)manager.CreateObject(mylib.CharCode.LiftFall,x+bw*2.5-lw,y+wireLength*.5,0);


			RR.Y=y+wireLength*.5;
			LL.Y=y+wireLength*.5;
			

			l=new Sprite(x+charBodyWidth*(-2.5),y+charBodyHeight,z);
			l.BitmapID=imgWire;
			l.SetSize(charWireWidth,LL.Y-y+LL.FloorTop-charBodyHeight);
			l.Visible=true;

			r=new Sprite(x+charBodyWidth*(+2.5),y+charBodyHeight,z);
			r.BitmapID=imgWire;
			r.SetSize(charWireWidth,RR.Y-y+RR.FloorTop-charBodyHeight);
			r.Visible=true;


			SetSize();

		}






//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(!active)return false;
			double w=wireLength;
			bool moveflag=false;
			if(LL.YMove!=0){
				double ly=LL.Y-y;
				w-=ly;
				RR.Y=y+w;
				moveflag=true;
			}
			else
			if(RR.YMove!=0){
				double ry=RR.Y-y;
				w-=ry;
				LL.Y=y+w;
				moveflag=true;
			}
		   if(moveflag==true){
			l.SetSize(charWireWidth, Math.Abs((LL.Y-y+LL.FloorTop)-charBodyHeight+3) );
			r.SetSize(charWireWidth, Math.Abs((RR.Y-y+RR.FloorTop)-charBodyHeight+3) );
		   }
		   if(w<charBodyHeight*1.5){
			LL.YMove=-10;RR.YMove=-10;
			LL.AutoMove=1;
			RR.AutoMove=1;
			active=false;
			Player p=manager.GetPlayerObject(0);
			p.GetScore(score);
			manager.CreateMessage(score.ToString(),p.X,p.Y);
		   }
		  return true;

		}



		public override  void SetSize(){
			SetSize(charSpriteWidth,charSpriteHeight);
			if(l!=null)l.SetSize(l.Width,l.Height);
			if(r!=null)r.SetSize(r.Width,r.Height);
		}


		public override bool OnCollision(MCharacter obj){// sg
		 return false;
		}

		public override bool DrawEntry(){
			if(l!=null)l.DrawEntry();
			if(r!=null)r.DrawEntry();
			return base.DrawEntry();
		}

		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
		 if(alive<0)return -1;
			if(l!=null)l.Kill();
			if(r!=null)r.Kill();
		  return base.Kill(kmode);
		}






	}
}