namespace mylib
{
	using System.Collections;
	using System.Drawing;
	using System;
	using mylib;

	class SystemConfig{
		public const int MaxSprites=1024;
		public const int DefaultVScreenWidth  = 512;
		public const int DefaultVScreenHeight = 448;
	}

	class GameConfig{
		public const int Life = 3;
		public const int HiScore = 100000;
		public const int DefaultGameTimer = 300;
		public static readonly int[] FlagBonusTable=new int[]{50,100,200,400,800,1000,2000,2000};
		public static readonly int[] BonusTable = new int[]{400, 500, 800, 1000, 2000, 4000, 5000, 8000};
		
		public const int DefaultFireballs=2;
		public const int MaxFireballs = 40;
	}

	
	class StageMode
	{
//		enum int mode{Normal=0,Underground=1,Water=2,Castle=3,Heaven=4};
		public const int Normal = 0;
		public const int Underground = 1;
		public const int Water = 2;
		public const int Castle = 3;
		public const int Heaven = 4;
		
		public static readonly string[] StageSrc = 
			new string[]{
				"stage0.txt", 

				"stage1-1.txt", 
				"stage1-2.txt", 
				"stage1-3.txt", 
				"stage1-4.txt", 

				"stage2-1.txt", 
				"stage2-2.txt", 
				"stage2-3.txt", 
				"stage2-4.txt", 

				"stage3-1.txt", 
				"stage3-2.txt", 
				"stage3-3.txt", 
				"stage3-4.txt", 

				"stage4-1.txt", 
				"stage4-2.txt", 
				"stage4-3.txt", 
				"stage4-4.txt", 

				"stage5-1.txt", 
				"stage5-2.txt", 
				"stage5-3.txt", 
				"stage5-4.txt", 

				"stage6-1.txt", 
				"stage6-2.txt", 
				"stage6-3.txt", 
				"stage6-4.txt", 

				"stage7-1.txt", 
				"stage7-2.txt", 
				"stage7-3.txt", 
				"stage7-4.txt", 

				"stage8-1.txt", 
				"stage8-2.txt", 
				"stage8-3.txt", 
				"stage8-4.txt", 

				"stage9-1.txt"
				};
	}
	
	class BGcolor
	{
		public static readonly Color SkyBlue      = Color.FromArgb(0x00, 0xdf, 0xff);
		public static readonly Color NightBlack   = Color.FromArgb(0x00, 0x00, 0x33);
		public static readonly Color UgBlack      = Color.FromArgb(0x00, 0x00, 0x00);
		public static readonly Color WaterBlue    = Color.FromArgb(0x38, 0x38, 0xff);
		public static readonly Color SunsetOrange = Color.FromArgb(0xff, 0x66, 0x00);
		public static readonly Color PaperWhite   = Color.FromArgb(0xff, 0xf0, 0xf0);
	}
	
	
	class Blocks
	{
		public const int Blank  = 0x00;
		public const int SoftBlock = 0x01;
		public const int Ground = 0x02;
		public const int Empty  = 0x03;
		public const int HardBlock = 0x04;
		public const int Bridge = 0x05;
		public const int Coin   = 0x06;
		
		public const int Goal   = 0x7f;
		public const int GoalFlag = 0x6d;
		public const int Tsuta  = 0x6c;

		public const int BarTop	= 0x6d;
		public const int Bar	= 0x6e;

		public const int CoinBlock = 0x10;
		public const int HiddenCoinBlockA = 0x20;
		public const int HiddenCoinBlockB = 0x30;

		public const int KinokoBlock = 0x11;
		public const int HiddenKinokoBlockA = 0x21;
		public const int HiddenKinokoBlockB = 0x31;

		public const int StarBlock = 0x12;
		public const int HiddenStarBlockA = 0x22;
		public const int HiddenStarBlockB = 0x32;
		
		
		//NORMAL
		public static readonly string[] SetA = new string[]{"", "img/block1.gif", "img/block2.gif", "img/block3.gif", "img/block4.gif", "img/block1.gif", "img/coinA.gif", "", "img/dokanVL.gif", "img/dokanVR.gif", "img/dokanVHL.gif", "img/dokanVHR.gif", "img/dokanHU.gif", "img/dokanHD.gif", "img/dokanHHU.gif", "img/dokanHHD.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "", "", "", "", "", "", "", "", "", "", "", "img/block1.gif", "img/block1.gif", "img/block1.gif", "img/block1.gif", "img/block1.gif", "img/block1.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "img/dokanDR.gif", "img/dokanLD.gif", "img/dokanUR.gif", "img/dokanLU.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "img/tsuta.gif", "img/ball.gif", "img/bar.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
		
		// UNDERGROUND
		public static readonly string[] SetB = new string[]{"", "img/block1D.gif", "img/block2D.gif", "img/block3D.gif", "img/block4D.gif", "img/block1D.gif", "img/coinA.gif", "", "img/dokanVL.gif", "img/dokanVR.gif", "img/dokanVHL.gif", "img/dokanVHR.gif", "img/dokanHU.gif", "img/dokanHD.gif", "img/dokanHHU.gif", "img/dokanHHD.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "", "", "", "", "", "", "", "", "", "", "", "img/block1D.gif", "img/block1D.gif", "img/block1D.gif", "img/block1D.gif", "img/block1D.gif", "img/block1D.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "img/dokanDR.gif", "img/dokanLD.gif", "img/dokanUR.gif", "img/dokanLU.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "img/tsuta.gif", "img/ball.gif", "img/bar.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
		
		// WATER
		public static readonly string[] SetC = new string[]{"", "img/sango.gif", "img/block7.gif", "img/block3D.gif", "img/block7.gif", "img/block1.gif", "img/coinA.gif", "img/water.gif", "img/dokanVL.gif", "img/dokanVR.gif", "img/dokanVHL.gif", "img/dokanVHR.gif", "img/dokanHU.gif", "img/dokanHD.gif", "img/dokanHHU.gif", "img/dokanHHD.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "", "", "", "", "", "", "", "", "", "", "", "img/block1D.gif", "img/block1D.gif", "img/block1D.gif", "img/block1D.gif", "img/block1D.gif", "img/block1D.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "img/dokanDR.gif", "img/dokanLD.gif", "img/dokanUR.gif", "img/dokanLU.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "img/tsuta.gif", "img/ball.gif", "img/bar.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
		
		//CASTLE
		public static readonly string[] SetD = new string[]{"", "img/block1G.gif", "img/block2G.gif", "img/block3.gif", "img/block5G.gif", "img/block6.gif", "img/coinA.gif", "", "img/dokanVL.gif", "img/dokanVR.gif", "img/dokanVHL.gif", "img/dokanVHR.gif", "img/dokanHU.gif", "img/dokanHD.gif", "img/dokanHHU.gif", "img/dokanHHD.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "img/hatenaA.gif", "", "", "", "", "", "", "", "", "", "", "", "img/block1D.gif", "img/block1G.gif", "img/block1G.gif", "img/block1G.gif", "img/block1G.gif", "img/block1G.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "img/dokanDR.gif", "img/dokanLD.gif", "img/dokanUR.gif", "img/dokanLU.gif", "img/akakage.gif", "img/magma.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "img/tsuta.gif", "img/ball.gif", "img/bar.gif", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
	}
	
	
	
	class CharCode
	{
		//Zalo
		public const int Chubo = 0x80;
		public const int KameGR = 0x81;
		public const int KameRD = 0x82;
		public const int KameBK = 0x83;
		public const int Pata = 0x84;
		public const int PataV = 0x85;
		public const int PataH = 0x86;
		public const int Toge = 0x87;
		public const int Tamago = 0x1092;
		public const int PakkunGR = 0x88;
		public const int PakkunRD = 0x89;
		public const int CannonBall = 0x8a;
		public const int Cannon = 0x8b;
		public const int Sakana = 0x8c;
		public const int Sakanakana = 0x108c;
		public const int Tobiuo = 0x8d;
		public const int Ika = 0x8e;
		public const int FireBubble = 0x8f;
		
		public const int HammerBaki = 0x90;
		public const int Hammer = 0x1090;
		public const int Kumozo = 0x91;
		public const int Breath = 0x93;
		//Boss
		public const int Kamezo = 0xb0;
		public const int KamezoBreath = 0x10b0;
		
		public const int FirebarR = 0xc0;
		public const int FirebarL = 0xc1;
		public const int FirebarLR = 0xc2;
		public const int FirebarLL = 0xc3;
		
		public const int JumpBlock = 0xc8;
		public const int SuperJumpBlock = 0xc9;
		
		public const int LiftUp = 0xe0;
		public const int LiftDown = 0xe1;
		public const int LiftLeft = 0xe2;
		public const int LiftRight = 0xe3;
		public const int LiftFall = 0xe4;
		public const int LiftRise = 0xe5;
		public const int LiftUpDown = 0xe6;
		public const int LiftLR = 0xe7;
		public const int Kumo_Right = 0xe8;
		public const int BalanceLift = 0xe9;
		
		// Item
		public const int Bounce = 0x2000;
		public const int BounceBlock = 0x2000;
		public const int Kinoko = 0x3000;
		public const int Flower = 0x3001;
		public const int Star = 0x3002;
		public const int Iget = 0x3003;
		public const int Tsuta = 0x3004;
		public const int TenCoin = 0x3005;
		public const int Poison = 0x3006;
		public const int Coin = 0x3007;
		public const int GoldenAxe = 0xf0;
		// Warp
		public const int DokanUp = 0xf1;
		public const int DokanDown = 0xf2;
		public const int DokanLeft = 0xf3;
		public const int DokanRight = 0xf4;
		public const int TsutaUp = 0x5005;
		
		public const int Castle = 0xca;
		public const int CastleExcellent = 0xcb;
		public const int Princess = 0xcc;
		
		// Effect
		public const int ScoreEffect      = 0x4000;
		public const int DyingEffect      = 0x4001;
		public const int FireballEffect   = 0x4002;
		public const int DustEffect       = 0x4003;
		public const int HanabiEffect     = 0x4004;
		public const int BrokenEffect     = 0x4005;
		public const int BounceEffect     = 0x4006;
		public const int AwaEffect        = 0x4007;
		public const int BounceCoinEffect = 0x4008;
		public const int ShadowCharacterEffect = 0x4009;
	}




	public enum KillMode{
		Drop=0,Star=1,Upper=2,Fire=3,Kick=4,Press=5,Other=-1
			}
/*
	class KillMode
	{
		public const int Drop = 0;
		public const int Star = 1;
		public const int Upper = 2;
		public const int Fire = 3;
		public const int Kick = 4;
		public const int Press = 5;
		
		public const int Other =-1;
	}
*/

	class Zindex{
		public const double BgEnemyZ = 95;

		public const double StageZ   = 100;

		public const double BasicZ   = 101;
		public const double EnemyZ   = 105;
		public const double ItemZ    = 105;
		public const double PlayerZ  = 110;

		public const double LiftZ    = 115;

		public const double EffectZ  = 120;
	}

	public enum Mind{
		Player= 0,
		Enemy = 1,
		Item  = 2,
		Upper = 3,
		Kick  = 4,
		Fire  = 5,
		Other = 6,
		Dummy =-1
	}
/*
	class Mind{
		 public const int Player= 0;
		 public const int Enemy = 1;
		 public const int Item  = 2;
		 public const int Upper = 3;
		 public const int Kick  = 4;
		 public const int Fire  = 5;
		 public const int Other = 6;
		 public const int Dummy =-1;
	}
*/

	class EnemyParameter
	{
		//--------------------------
		public const string Chubo_imgWalk = "img/KRwalkR.gif";
		public const string Chubo_imgDie = "img/KRwalkR.gif";
		
		
		//--------------------------
		public const string KameGR_imgWalk = "img/KMGwalkR.gif";
		public const string KameGR_imgDie = "img/KMGsleep.gif";
		public const string KameGR_imgSleep = "img/KMGsleep.gif";
		public const string KameGR_imgWake = "img/KMGwake.gif";
		
		public const string KameRD_imgWalk = "img/KMRwalkR.gif";
		public const string KameRD_imgDie = "img/KMGsleep.gif";
		public const string KameRD_imgSleep = "img/KMGsleep.gif";
		public const string KameRD_imgWake = "img/KMRwake.gif";
		
		public const string KameBK_imgWalk = "img/KMBwalkR.gif";
		public const string KameBK_imgDie = "img/KMBsleep.gif";
		public const string KameBK_imgSleep = "img/KMBsleep.gif";
		public const string KameBK_imgWake = "img/KMBwake.gif";
		
		public const string KameK_imgWalk = "img/katochanwalkR.gif";
		public const string KameK_imgSleep = "img/katochansleep.gif";
		public const string KameK_imgWake = "img/katochanwake.gif";
		public const string KameK_imgDie = "img/katochansleep.gif";
		
		
		public const string Toge_imgWalk = "img/togeR.gif";
		public const string Toge_imgSleep = "img/togeR.gif";
		public const string Toge_imgWake = "img/togeR.gif";
		public const string Toge_imgDie = "img/togeR.gif";
		
//		public static int TogeMax = 4;
		
		public const string Kumozo_imgWalk = "img/kumozo.gif";
		public const string Kumozo_imgDie = "img/kumozo.gif";
		
		public const int KameSleepTime = 150;
		public const double KameKickSpeed = 11.5;
		
		
		//--------------------------
		public const string PataGR_imgWalk = "img/PATAgrnR.gif";
		public const string PataGR_imgDie = "img/KMGsleep.gif";
		
		public const string PataRD_imgWalk = "img/PATAredR.gif";
		public const string PataRD_imgDie = "img/KMGsleep.gif";
		
		//--------------------------
		public const string MFlowerGR_imgWalk = "img/Mflower.gif";
		public const string MFlowerGR_imgDie = "img/Mflower.gif";
		public const string MFlowerRD_imgWalk = "img/Mflower.gif";
		public const string MFlowerRD_imgDie = "img/Mflower.gif";
		public const int MFlowerWaitTop = 25; // LтԂŒ~t[
		//--------------------------
		public const string KamezoBreath_imgWalk = "img/breath.gif";
		public const string CannonBall_imgWalk = "img/cannonballR.gif";
		public const string Toriyama_imgWalk = "img/toriyamaR.gif";
		
		public const string Sakana_imgWalk = "img/sakanaR.gif";
		public const string Sakana_imgDie = "img/sakanaR.gif";
		public const string Sakana2_imgWalk = "img/sakanaGR.gif";
		public const string Sakana2_imgDie = "img/sakanaGR.gif";
		
		public const string Tobiuo_imgWalk = "img/sakanaR.gif";
		public const string Tobiuo_imgDie = "img/sakanaR.gif";
		
		public const string Ika_imgWalk = "img/ika.gif";
		public const string Ika_imgWalk2 = "img/ikaswim.gif";
		public const string Ika_imgDie = "img/ika.gif";
		
		public const string Cannon_imgWalk = "img/cannon.gif";
		public static int Cannon_attackRate = 300;
		
		public const string Tamago_imgWalk = "img/tamago.gif";
		public const string Tamago_imgDie = "img/togeR.gif";
		
//		public static int CannonMax = 4;
//		public static int CannonballMax = 4;
		public static int LiveCannonMax = 4;
		private static int liveCannonCnt = 0;
		private static int liveCnt = 0;
		public static int LiveCannonCnt{
			get {
				return liveCannonCnt;
			}
			set {
				liveCannonCnt=value;
			}
		}
		public static int LiveCnt{
			get {
				return liveCnt;
			}
			set {
				liveCnt=value;
			}
		}
		
		
		//--------------------------
		public const string HammerBaki_imgWalk = "img/bakiR.gif";
		public const string HammerBaki_imgDie = "img/bakiR.gif";
		public const int HammerBaki_hammerRate = 80; // n}[x6𓊂ɋx~t[
		public const int HammerBaki_hammerRate2 = 15; // n}[𓊂Ԋu(t[)
		public const int HammerBaki_jumpRate = 40;
		public static double HammerBaki_xMove = 1.5;
		public static double HammerBaki_xAccel = 1;
		public static double HammerBaki_yAccel = 4;
		public static double HammerBaki_yJump = 23.5;
		public const double HammerBaki_ySpeedMax = 11;
		public static int HammerBaki_dashStart = 15 * 128; // ΂炭ƓːiĂ
		
		
		public static double HammerObject_xMove = 5;
		public static double HammerObject_yAccel = 2;
		
		public static double HammerObject_yMove = - 22.2;
		
		public static double HammerObject_ySpeedMax = 20;
		
		public static string HammerObject_imgWalk = "img/hammer.gif";
		public static string HammerObject_imgDie = "img/hammer.gif";
		
		//--------------------------
		
		public const string Kamezo_imgWalk = "img/kamezoR.gif";
		public const string Kamezo_imgDie = "img/kamezoR.gif";
		public const string Kamezo_imgBreath = "img/kamezoR.gif";
		public static readonly string[]
				 Kamezo_nakami = 
				 	new string[]{
						"img/KRwalkR.gif", 
						"img/KRwalkR.gif", 
						"img/KMGsleep.gif", 
						"img/KMBsleep.gif", 
						"img/sakanaR.gif", 
						"img/togeR.gif", 
						"img/kumozo.gif", 
						"img/bakiR.gif", 
						"img/kamezoR.gif"
					};
		public static string GetKamezoNakami(int n)
		{
			if (n < 0 || n >= Kamezo_nakami.Length)
				return Kamezo_imgDie;
			else
				return Kamezo_nakami[n];
		}
		public static double Kamezo_life = 5; // t@CA[ϋ
		public static double Kamezo_xAccel = .5;
		public static double Kamezo_yAccel = 0.3;
		public static double Kamezo_yJump = 6.5;
		// T̉ʎO牊ł邩
		public static double Kamezo_fireReach = 5;
		// [hn}[𓊂Ă邩
		public static int Kamezo_hammerWorld = 6;
		
		public static int Kamezo_breathRate = 60;
		public static int Kamezo_hammerRate = 200;
		public const int Kamezo_jumpRate = 150;
		
		
		//--------------------------
		public const string FireBubble_imgWalk = "img/bubble.gif";
		public const string FireBubble_imgDie = "img/bubble.gif";
		public const double FireBubble_yJump = 40.1; // Wvx
		public const double FireBubble_yAccel = 2; // d͉x
		public const int FireBubble_jumpRate = 40; // nx~t[
		
		public const string FireBar_imgWalk = "img/fireball.gif";
		public static double FireBar_rotSpeed = 2;
		
		//--------------------------
		
		public const string Lift_imgWalk = "img/lift.gif";
		public const string Lift_imgDie = "img/lift.gif";
		public const string KumoLift_imgWalk = "img/kumolift.gif";
		public const double Lift_defaultWidth = 32 * 3; //
		public static double Lift_liftWidth = 32 * 3; //
		
		public const string BalanceLift_imgWalk = "img/wiretop.gif";
		public const string BalanceLift_imgArm = "img/wiretop.gif";
		public const string BalanceLift_imgWire = "img/wire.gif";
		
		//--------------------------
		public const string JumpBlock_imgWalk = "img/jump.gif";
		
		
		//--------------------------
		
		public const string Kinoko_imgWalk = "img/kinoko.gif";
		public const string Flower_imgWalk = "img/flower.gif";
		public const string Star_imgWalk = "img/star.gif";
		public const string Tsuta_imgWalk = "img/tsutatop.gif";
		public const string Iget_imgWalk = "img/1up.gif";
		public const string Poison_imgWalk = "img/inoko.gif";
		
		
		//--------------------------
		public const string GoalFlag_imgWalk = "img/goalflag.gif";
		public const string CastleFlag_imgWalk = "img/castleflag.gif";
		//--------------------------
		public const string GoldenAxe_imgWalk = "img/axe.gif";
		public const string GoldenAxe_imgDie = "img/axe.gif";
		//--------------------------
		//--------------------------
		//--------------------------
		//--------------------------
		//--------------------------
		//--------------------------
		//--------------------------
		//--------------------------
	}











	public enum ActionMode{Run=0,Swim=1,Fly=2} 
	class PlayerMode
	{
		public const int playerZ = 103;
		
		public const int Normal = 0;
		public const int Super = 1;
		public const int Fire = 2;
		
		public const int Damage = 10;
		public const int Die = 11;
		public const int Ghost = 12;
		public const int NGhost = 13;
		public const int Star = 14;
		public const int NStar = 15;
		public const int Timeover = 16;
		public const int Goal = 17;
		public const int Axe = 18;
		public const int TimeBonus = 19;
		public const int Drop = 20;
		public const int Saitama = 12345;
		
		public const int DokanUp = 30;
		public const int DokanDown = 31;
		public const int DokanLeft = 32;
		public const int DokanRight = 33;
		public const int DokanUpOut = 34;
		public const int DokanDownOut = 35;
		public const int DokanLeftOut = 36;
		public const int DokanRightOut= 37;
		public const int TsutaUp = 38;
		public const int TsutaUpOut = 39;
		
		
		public const int Pause = 50;
		
		public const int Scroll = 60;
		
		public const string imgStand = "img/PLstandR.gif";
		public const string imgWalk = "img/PLwalkR.gif";
		public const string imgRun = "img/PLrunR.gif";
		
		public const string imgJump = "img/PLjumpR.gif";
		public const string imgBrake = "img/PLbrakeR.gif";
		public const string imgDie = "img/PLdieR.gif";
		//	public static final String imgFire  = "img/PLfireR.gif";
		public const string imgFire = "img/PLstandR.gif";
		public const string imgSit = "img/PLsitR.gif";
		public const string imgClimb = "img/PLwall.gif"; // c^EǏ@~
		public const string imgClimbMove = "img/PLwallC.gif"; // ړ
		public const string imgSwim = "img/PLswimR.gif";
		public const string imgSwimMove = "img/PLswimBR.gif";
		public const string imgBar = "img/PLbarR.gif"; // |[
		
		public const string imgFireball = "img/fireball.gif";
	}
	
	class ItemCode
	{

		public const int Coin   = 1;
		public const int Kinoko  = 2;
		public const int Flower = 3;
		public const int Star   = 4;
		public const int Iget   = 5;
		public const int IgetNum = 999999;
		
		public const int GoldenAxe = 10;
		
		public const int DokanUp    = PlayerMode.DokanUp;
		public const int DokanDown  = PlayerMode.DokanDown;
		public const int DokanLeft  = PlayerMode.DokanLeft;
		public const int DokanRight = PlayerMode.DokanRight;
		public const int TsutaUp    = PlayerMode.TsutaUp;
		
		public const int Poison = 99;
	}


}