namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class FireBar: Chubo{
		private double rotate=0;
		private double rotR=0;
		private double barLength;
		private int balls=6;
		private int charFireWidth;
		private int charFireHeight;
		private double rx;
		private double ry;
		private Sprite[] fireball;

		public FireBar(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){




			imgWalk  = getImageID(EnemyParameter.FireBar_imgWalk);
			imgDie   = imgWalk;
			Face=imgWalk;
			
			registFire  = 2; //
			registUpper = 2; //
			registKick  = 2; //
			registPress = 2; //
			balls=6;

			charBodyWidth  = 16;
			charBodyHeight = 16;
			charFireWidth  = 16;
			charFireHeight = 16;
			charSpriteWidth  = charFireWidth  * balls;
			charSpriteHeight = charFireHeight * balls;
			 if(
			    charCode==mylib.CharCode.FirebarLL ||
			    charCode==mylib.CharCode.FirebarLR){
			   balls=11;
			   charSpriteWidth  *= 2;
			   charSpriteHeight *= 2;
			 }
			 cSprX=charFireWidth  / 2;
			 cSprY=charFireHeight / 2;

			hasGroupCollision=false;



			 x=Math.Floor(x/manager.BlockWidth ) * manager.BlockWidth  + manager.BlockWidth  / 2;
			 y=Math.Floor(y/manager.BlockHeight) * manager.BlockHeight + manager.BlockHeight / 2;

			rotate=0.1+manager.M(360);
			rotR=EnemyParameter.FireBar_rotSpeed;
			 switch(charCode){
			  case mylib.CharCode.FirebarR: goto case mylib.CharCode.FirebarLR;
			  case mylib.CharCode.FirebarLR:
			   rotR =  Math.Abs(rotR);
			  break;
			  case mylib.CharCode.FirebarLL: goto case mylib.CharCode.FirebarL;
			  case mylib.CharCode.FirebarL:
			   rotR = -Math.Abs(rotR);
			  break;
			 }
			

			fireball= new Sprite[balls];

			for(int i=0;i<balls;i++){
				fireball[i]=new Sprite(x,y,Zindex.EnemyZ+1);
				//fireball[i].setBitmap(face);
				fireball[i].BitmapID=Face;
				fireball[i].SetSize(charFireWidth,charFireHeight);
				fireball[i].Visible=true;
			}


			barLength=balls*charBodyHeight-16;
			rx=  0;
			ry= -charBodyHeight;


			manager.SetXYPointObject(x,y,Blocks.Empty);




		}






//----------------------
		public override bool Action(){

		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0)return false;
		 innerTimer++;


		  rotate+=rotR;

		  while(rotate<0)rotate=360-rotate;

		  if(rotate%90==0)rotate+=.01;// SɐɂȂȂ悤ɂ邽߂̎蔲

		  double r=Math.PI*2/360*rotate;

		  rx= - (-charBodyWidth ) * Math.Sin(r);
		  ry= + (-charBodyHeight) * Math.Cos(r);


		 return true;






		}



		public override bool Collision(MCharacter obj){
		 if((obj.Mind!=mylib.Mind.Player) && (obj.Mind!=mylib.Mind.Fire))return false;

		 if(alive<0)return false;
		 if(obj.Alive<0)return false;
		 if(manager.CheckScreen(this) < 0)return false;

		 // ͂߂ɂ܂ȓ蔻
		 if(Math.Abs(x-obj.X) > barLength + obj.Width )return false;
		 if(Math.Abs(y-obj.Y) > barLength + obj.Height)return false;
		 if(rotate % 180 == 90)return false; //蔲




		  double[] xp={	obj.X,
				obj.X + obj.Width,
				obj.X,
				obj.X + obj.Width
		  };
		  double[] yp={	obj.Y,
				obj.Y,
				obj.Y + obj.Height,
				obj.Y + obj.Height
		  };

		  // ̐^
		  double rrcX = rx*balls / 2 + x;
		  double rrcY = ry*balls / 2 + y;
		  double rr   = barLength * barLength / 4;

		  double xm=-ry/rx;

		  int rgt=0,lft=0;
		  for(int i=0;i<xp.Length;i++){ //̉Eɂ_ƍɂ_JEg
			double xs=x-xp[i];
			if(xm*xs + y > yp[i])	lft++;
			else			rgt++;
		  }

			// SɈ͂ł܂傫̃Lɂ͎gȂ
		  if( rgt > 0 && lft > 0 ){
		   for(int i=0;i<xp.Length;i++){
			double cx=rrcX-xp[i];
			double cy=rrcY-yp[i];
			if(cx*cx+cy*cy < rr)return true;
		   }
		  }
			return false;
		}








		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
			if(alive<0)return -1;
			 for(int i=0;i<balls;i++){
				if(fireball[i]!=null)fireball[i].Kill();
				fireball[i]=null;
			 }
		  return base.Kill(kmode);
		}




		public override bool DrawEntry(){
		  double rxx=rx;//*1.1;
		  double ryy=ry;//*1.1;
			 for(int i=0;i<balls;i++){
				if(fireball[i]!=null){
				 fireball[i].MoveTo(x+rxx*i-cSprY,y+ryy*i-cSprY);
				 fireball[i].DrawEntry();
				}
			 }
			return true;
		}

//----------------------
		public override void SetSize(){
			SetSize(charFireWidth,charFireHeight);
		}
		public override void SetSize(int ww,int hh){
			if(fireball == null)return;
			 for(int i=0;i<balls;i++){
				if(fireball[i]!=null)
					fireball[i].SetSize(ww,hh);
			 }
			cSprX=(ww-charFireWidth)/2;
			cSprY=(hh-charFireHeight)/2;
		}




	}
}