namespace mylib
{
	using System.Drawing;
	using System.Drawing.Drawing2D;
	using System.Collections;
	using System.Net;
	using System;
	using mylib;
	using System.Drawing.Imaging;

#if MDX
	using Microsoft.DirectX;
	using Microsoft.DirectX.Direct3D;
#endif

	public class ILoader{

		private Hashtable table;
		private ArrayList images;
		private ArrayList names;
		private ArrayList animList;

		private Bitmap undef;
//		private String undef_gif="img/undefined.gif";
		private ScreenManager manager;

#if MDX
		private ArrayList textures;
		private Texture undefTex;
#endif

		public ILoader(ScreenManager E){
			manager=E;

			table  = new Hashtable();
			images = new ArrayList();
			names  = new ArrayList();
			animList= new ArrayList();
			createUndefImage();

		}

		public Image GetImage(string str){
			int i=GetImageID(str);
			return GetImageData(i);
		}

		private void createUndefImage(){
			undef=new Bitmap(32,32);
			Graphics g = Graphics.FromImage(undef);
			g.Clear(Color.Red);
			g.Dispose();
			images.Add(undef);
			names.Add("undefined");
			table.Add("undefined",0);
			
#if MDX
			textures = new ArrayList();
			textures.Add(new AnimatedTexture(undef,manager.DxDevice));
			undefTex = ((AnimatedTexture)textures[0]).Texture;
#endif
		}

		public int GetImageID(string str){
			if(str.Equals(""))return 0;
			if(str==null)return 0;
//			System.int32 ret;
			int ret=0;
			 if(table.ContainsKey(str)){
//				manager.DBGn("images o^ς"+str+" "+(int)table[str]);
				ret = ((int)table[str]);
			 }else{
				int vcs=images.Count;
				Bitmap im=null;
				 im = OpenImage(str);
				
				if(im==null){
					return 0;
				}

				ret = vcs;
				images.Add(im);
				names.Add(str);
				table.Add(str, ret );
#if MDX
				if(vcs!=0)textures.Add(new AnimatedTexture(im,manager.DxDevice));
#else
				if(vcs!=0)ImageAnimator.Animate(im, 
						new EventHandler(this.OnFrameChanged));
#endif
			}
			return ret;
		}
		private Bitmap OpenImage(string str){//Uri uri=null;
		 try{
			if(manager.CodeBase.IndexOf("http://")>=0){
				Uri uri = new Uri(manager.CodeBase+str);
				return new Bitmap(WebRequest.Create(uri).GetResponse().GetResponseStream());
				
			}else{
				return new Bitmap(str);
			}
		 }catch(Exception e){
				manager.DBGn("Image loading error "+str+" "+e);
				return undef;
		 }
			
		}
		private void OnFrameChanged(object o, EventArgs e) {
			try{
			
			animList.Add(o);
			// while(manager.Drawing){
//				//Sleep(5);
//				if(!manager.Drawing)
//					 ImageAnimator.UpdateFrames((Image)o);
			}catch(Exception ev){
				manager.DBGn("  Exception iLoader.OnFrameChanged"+ev);
			}

		}
		public void UpdateFrames(){
		  try{
//			foreach(object o in animList){
			for(int i=0;i<animList.Count;i++){
				ImageAnimator.UpdateFrames((Image)animList[i]);
			}
			animList.Clear();
		   }catch(Exception ex){
			manager.DBGn("  Exception iLoader.UpdateFrames"+ex);
		   }
		}

		public Image GetImageData(int ID){
			if(ID > images.Count || ID < 0){
				manager.DBG("images ͈͊O ["+ID+"]");
				return undef;
			}else{
			   return ((Image)images[ID]);
			}
			
		}
		Image this[int ID]{
			get{
				return GetImageData(ID);
			}
		}

		public string GetImageName(int ID){
			if(ID > names.Count || ID < 0){
				return "";
			}else{
			   return ((string)names[ID]);
			}
			
		}

		public static bool IsMultiFrame(Image img){
		 Guid[] DimensionList = img.FrameDimensionsList;
		 int cnt=0;
		 foreach(Guid dimens in DimensionList ){
			 FrameDimension fd = new FrameDimension(dimens);
			  cnt+= img.GetFrameCount(fd);
		 }
		 //Console.WriteLine("frameCount="+cnt+"  "+img);
		 if(cnt > 1)	return true;
		 else		return false;
		}

		public void Dispose(){
			for(int i=0;i<names.Count;i++){
#if MDX
				((AnimatedTexture)textures[i]).Dispose();
#endif
			}
		}

#if MDX
		public Texture GetTextureData(int ID){
			if(ID > textures.Count || ID < 0){
				manager.DBG("textures ͈͊O ["+ID+"]");
				return undefTex;
			}else{
//			   return ((AnimatedTexture)textures[ID]).Texture;
			   return ((AnimatedTexture)textures[ID]).Texture;
			}
			
		}
#endif


	}









#if MDX

//MEMO



public class AnimatedTexture{
	private Bitmap srcBitmap;
	private Texture[] texture;
	private ArrayList animTexture;
	private int currentFrame=0;
	private int frameCount=0;

	public AnimatedTexture(Bitmap bmp,Device device){
		init(bmp,device);
	}
	
	private void init(Bitmap bmp,Device device){
	 srcBitmap=bmp;
	 animTexture = new ArrayList();

	 Guid[] DimensionList = srcBitmap.FrameDimensionsList;
	 foreach(Guid dimens in DimensionList ){
		 FrameDimension fd = new FrameDimension(dimens);
		  int Pages = srcBitmap.GetFrameCount(fd);
		   for( int frameIndex = 0; frameIndex < Pages; frameIndex++ ) {
			  srcBitmap.SelectActiveFrame(fd, frameIndex); 
			  animTexture.Add(bmpToTexture(srcBitmap,device));
		   }
	 }


		frameCount = animTexture.Count;

		texture = new Texture[animTexture.Count];
		if(animTexture.Count>1){
			ImageAnimator.Animate(srcBitmap,new EventHandler(this.OnFrameChanged));
		}
		else	texture[0]=bmpToTexture(srcBitmap,device);

		for(int i=0;i<animTexture.Count;i++){
			texture[i]=(Texture)animTexture[i];
		}

		animTexture.Clear();
	}

	private Rectangle rect1=new Rectangle(0,0,0,0);
	private Rectangle rect2=new Rectangle(0,0,64,64);
	private Texture bmpToTexture(Bitmap src,Device device){
		  Bitmap bbb=new Bitmap(size2X(srcBitmap.Width),size2X(srcBitmap.Height));
		  Graphics ggg=Graphics.FromImage(bbb);
		  ggg.Clear(Color.FromArgb(0,0,0,0));
//		  ggg.DrawImage(srcBitmap,0,0,srcBitmap.Width,srcBitmap.Height);
			rect1.Width  = srcBitmap.Width;
			rect1.Height = srcBitmap.Height;
			rect2.Width  = srcBitmap.Width;
			rect2.Height = srcBitmap.Height;
		  ggg.DrawImage(srcBitmap,rect2,rect1,GraphicsUnit.Pixel);
		  ggg.Dispose();
		  
		  return Texture.FromBitmap(device,bbb,0,Pool.Managed);
		
	}

	private void OnFrameChanged(object o,EventArgs e){
		currentFrame= (currentFrame+1) % frameCount;
	}


	public Texture Texture{
		get{
			return texture[currentFrame];
		}
	}



	private int size2X(int l){
		int x=2;
		for(int i=1;i<10;i++){x*=2;
			if(x >= l)return x;
		}
		return x;
	}

	public void Dispose(){
		for(int i=0;i<frameCount;i++){
			if(texture[i]!=null)texture[i].Dispose();
		}
	}


} // end AnimatedTexture



#endif




}