namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class Kamezo: Chubo{
		private bool hammerFlag;
		private int hammerRate;
//		private int hammerRate2;
		private int hammerCounter;
		private int jumpRate;
		private int jumpCounter;
		private int breathRate;
		private int breathCounter;

		private MCharacter lastBreath;
		private MCharacter slave;
		
		private double firstX;
		private double fireReach;
		private double headX,headY;
		private double charHeadWidth,charHeadHeight;


//		private int killFlag=0;

		private int imgBreath;

		public Kamezo(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){


		  int world = manager.GetWorldNumber();

			score      = 8000;
		
			life=5;

			jumpRate     = EnemyParameter.Kamezo_jumpRate;
			jumpCounter  = manager.M(jumpRate)+100;

			hammerFlag   = (world>=EnemyParameter.Kamezo_hammerWorld);
			hammerRate   = EnemyParameter.Kamezo_hammerRate;
			hammerCounter= manager.M(hammerRate)+100;

			breathRate   = EnemyParameter.Kamezo_breathRate;
			breathCounter= manager.M(breathRate)+100;

			xMove  = 0;
			xAccel = EnemyParameter.Kamezo_xAccel;
			yAccel = EnemyParameter.Kamezo_yAccel;
			yJump  = EnemyParameter.Kamezo_yJump;

			hasGroupCollision=false;
			fireReach = EnemyParameter.Kamezo_fireReach;


			registFire  = -1; //
			registUpper = -2; //
			registKick  =  2; //
			registPress =  2; //
			
			charBodyWidth =32;
			charBodyHeight=55;
			charSpriteWidth =64;
			charSpriteHeight=72;

			imgWalk  = getImageID(EnemyParameter.Kamezo_imgWalk);
			imgDie   = getImageID(EnemyParameter.GetKamezoNakami(world));
			imgBreath= getImageID(EnemyParameter.Kamezo_imgBreath);
			Face=imgWalk;

			Z=Zindex.BasicZ+1;

			charHeadWidth  = 16;
			charHeadHeight = 24;
			headX=x-charHeadWidth;
			headY=y;


			MCharacter m=manager.GetBoss();
			if(m!=null){slave=m;slave.SetMaster(this);}
			manager.SetBoss(this);

			firstX=x;

			SetSize();




		}






//----------------------
		public override bool Action(){

		 if(alive<1)return false;
		 innerTimer++;

		 bool iscreen=(manager.CheckScreen(this)>0);
		 Player p = manager.GetPlayerObject(0);

		 if(Math.Abs(x-p.X) > manager.VirtualWidth*fireReach){
			return false;
		 }


		  Face=imgWalk;
		  xMove=hFace*xAccel;
		  yMove+=yAccel;

		   double flPoint=y+charBodyHeight+yMove;
		  if(manager.GetXYPointObject(x+charBodyWidth/2,flPoint) != 0 ){
			yMove=0;
			y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
		  }



		   if(yMove==0 && jumpCounter < 0){
			yMove=-yJump;
			jumpCounter=manager.M(jumpRate)+20;
		   }else{
		   }

		   if(breathCounter < 0 ){//&& hFace < 0){
			if(iscreen){
				lastBreath=manager.CreateEnemy(CharCode.KamezoBreath,headX-charHeadWidth,y,hFace);
			}else
			{
			 manager.CallEnemy(CharCode.KamezoBreath);
			}
			 breathCounter=manager.M(breathRate)+100;
		   }


		  if(lastBreath != null){
			if(lastBreath.InnerTimer <  10){
				Face=imgBreath;
				lastBreath.Y+=3.2;
			}
		  }


		  if(hammerFlag && iscreen){
			if(hammerCounter < 0){
				if(hammerCounter > -30){
					if(hammerCounter % 5==0)manager.CreateEnemy(CharCode.Hammer,x,y,hFace).SetMaster(this);
				}else{
					  hammerCounter=manager.M(hammerRate)+50;
				}
			}
		  }

		  if(iscreen){
			if(Math.Abs(firstX-x) < manager.VirtualWidth * .8){
			 x+=xMove;
			}
			y+=yMove;
		  }else{
			x=firstX;
		  }

		  HFace=(p.X > x ) ? 1 : -1 ;
		  headX = (hFace > 0 ) ? (x+charBodyWidth):(x-charHeadWidth);
		  headY = y;

		  jumpCounter--;
		  breathCounter--;
		  hammerCounter--;
		  return true;





		}







		public override bool OnCollision(MCharacter obj){
		 if(alive<0)return false;
		 if(obj.Alive<0)return false;
		 if(manager.CheckScreen(this) < 0)return false;
		  switch(obj.Mind){
			case mylib.Mind.Player:
				obj.Damage(this);
				if(!((Player)obj).Ghost)manager.CreateMessage("GA!!",x,y);
			break;
			case mylib.Mind.Fire:
				life--;
				 if(life!=0)break;
				  
				  obj.GetScore(score);
//				  killFlag=KillMode.Fire;
				  Player p=manager.GetPlayerObject(0);
				  p.SetSaitama_saitama_saitama();
			break;
		  }
		 return true;
		}

		public override bool Collision(MCharacter obj){
		  if( (obj.Mind!=mylib.Mind.Player) && (obj.Mind!=mylib.Mind.Fire) )return false;
		  if(alive<0)return false;
		  bool flg=base.Collision(obj);
		  if(flg)return true;

			if(headX + charHeadWidth   < obj.X    ) return false;
			if(headY + charHeadHeight  < obj.Y    ) return false;
			if(headX > obj.X + obj.Width  ) return false;
			if(headY > obj.Y + obj.Height ) return false;
		 return true;
		}









		public override int Kill(){return Kill(KillMode.Other);}
		public override int Kill(KillMode kmode){
			if(alive<0)return -1;
			switch(kmode){
				case KillMode.Drop:
				 {
				  imgDie=imgWalk;
				  MCharacter dd =  manager.CreateEffect(CharCode.DyingEffect,x,y,0);
				  dd.SetMaster(this);
				  dd.YMove  = 0;
				  dd.YAccel = yAccel;
				  dd.XMove  = xMove;
				  dd.VFace  = 1;
//				  MCharacter msg =  manager.CenterMessage("I'll be back !!",manager.VirtualHeight,300);
//				  msg.YAccel=-.7;
//				  msg.XAccel= .3;
				 }
				break;
				case KillMode.Fire:
//				 if(master==null){
				{
				  MCharacter dd=manager.CreateEffect(CharCode.DyingEffect,x,y,0);
				  dd.SetMaster(this);
				  dd.YMove  = yMove;
				  dd.YAccel = yAccel;
				  dd.XMove  = xMove;
				 }
				break;
			}
//			Visible=false;
			manager.KillBoss();


			alive=-1;
			if(sprite!=null)base.Kill();
			sprite=null;
			master=null;
			manager=null;
			if(slave!=null){
				slave.Kill(KillMode.Other);
				slave=null;
			}
		 return -1;
		}






	}
}