namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	public class Lift : MCharacter{
//		private static double liftWidth=EnemyParameter.Lift_defaultWidth;
		private bool catching =false;
		private int autoMove=0;
		private double floorTop;
		private double floorBottom;
		private double floorHeight;

		 public const int liftUp     = 0;
		 public const int liftDown   = 1;
		 public const int liftLeft   = 2;
		 public const int liftRight  = 3;
		 public const int liftFall   = 4;
		 public const int liftRise   = 5;
		 public const int liftUpDown = 6;
		 public const int liftLR    = 7;
		 public const int liftKumo   = 8;
		private int liftMode=liftUp;

		public Lift(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			mind=Mind.Other;


			x=xx;
			y=yy;
			oldX=x;
			oldY=y;
			z=Zindex.LiftZ;
			liftMode=liftUp;
			score  = 1000;
			autoMove=0;

		 //ړp[^ ---
			xMove=0;
			xSpeedMax=8;
			xSpeedMin=.9;
			xAccel =4;
//			xBounce=1;
			
			yMove=-6;
			yAccel=0;
//			yDropSpeedMax=10;
			ySpeedMax=8;
			yJump    =0;
		 //ړp[^ --->

			imgWalk  = getImageID(EnemyParameter.Lift_imgWalk);
			imgDie   = getImageID(EnemyParameter.Lift_imgWalk);

			switch(charCode){
				case mylib.CharCode.LiftUp:
				 xMove=0;
				 yMove=-5;
				 xAccel=0;
				 yAccel=0;
				 liftMode=liftUp;
				break;
				case mylib.CharCode.LiftDown:
				 xMove=0;
				 yMove=5;
				 xAccel=0;
				 yAccel=0;
				 liftMode=liftDown;
				break;
				case mylib.CharCode.LiftLeft:
				 xMove =-5;
				 yMove = 0;
				 xAccel= 0;
				 yAccel= 0;
				 liftMode=liftLeft;
				break;
				case mylib.CharCode.Kumo_Right:
				 imgWalk=getImageID(EnemyParameter.KumoLift_imgWalk);
				 imgDie=imgWalk;
				 autoMove=-1;
				 xMove = 5;
				 yMove = 0;
				 xAccel=0;
				 yAccel=0;
				 liftMode=liftRight;
				break;
				case mylib.CharCode.LiftRight:
				 xMove = 5;
				 yMove = 0;
				 xAccel=0;
				 yAccel=0;
				 liftMode=liftRight;
				break;
				case mylib.CharCode.LiftFall:
				 xMove=0;
				 yMove=0;
				 xAccel=0;
				 yAccel=.8;
				 ySpeedMax=10;
				 liftMode=liftFall;
				break;
				case mylib.CharCode.LiftRise:
				 xMove=0;
				 yMove=0;
				 xAccel=0;
				 yAccel=-.8;
				 liftMode=liftRise;
				break;
				case mylib.CharCode.LiftUpDown:
				 xMove=0;
				 yMove=0;
				 xAccel=0;
				 yAccel=+0.25;
				 liftMode=liftUpDown;
				break;
				case mylib.CharCode.LiftLR:
				 xMove=0;
				 yMove=0;
				 xAccel=-.3;
				 yAccel=0;
				 liftMode=liftLR;
				break;
			}

		
			Face=imgWalk;


			charBodyWidth  = (int)Math.Floor(EnemyParameter.Lift_liftWidth);
			charBodyHeight = 32;
			charSpriteWidth  = (int)Math.Floor(EnemyParameter.Lift_liftWidth);
			charSpriteHeight = 32;
		
			floorHeight = 8;

			if(manager.GetStageMode()==StageMode.Water){
				charBodyHeight = 24;
				floorTop       = (charBodyHeight-floorHeight)/2;
			}

			floorTop    = (charBodyHeight-floorHeight)/2;
			floorBottom = floorTop + floorHeight;
			y-=floorTop;
			SetSize();


		}

	//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0)return false;
			 innerTimer++;
			 Player p=manager.GetPlayerObject(0);
			 bool lastC=catching;
				catching=false;
			  if( Collision(p)){
				double plc=p.X+p.Width/2;

				if(p.YMove <= 0){
				  if(plc<x){
					if(p.XMove>0)p.XMove=0;
					 p.X=x-p.Width;
					}
				  else
				  if(plc>x+charBodyWidth){
					if(p.XMove<0)p.XMove=0;
					p.X=x+charBodyWidth;
					}
				else
				if(p.YMove < 0){
				 if(p.YMove < yMove){
					p.YMove=.1;
					p.Y=y+floorBottom;
				 }else
				 if(p.Y > y+charBodyHeight){
				 }else
				 if(p.Y > y){
					p.YMove=.1;
					p.Y=y+floorBottom;
				 }else{
			//		p.YMove=.1;
				 }
				}
				}else{

				 if(p.Y >=y){
				 }else
				 if(p.Y + p.Height <= y + charBodyHeight){
					p.YMove=0;
					catching=true;
					p.Y=y+floorTop-p.Height;
				 }
				}
			  }else{
			  }
				if(lastC==true && catching==false){
					p.XMove+=xMove;
				}

				xMove+=xAccel;
				yMove+=yAccel;
			 

			  if(( liftMode==liftFall || liftMode==liftRise) && (!catching && autoMove<1))yMove=0;
			  else
			  if( (liftMode==liftUpDown || liftMode ==liftLR) && 
				(Math.Abs(xMove) > xSpeedMax || Math.Abs(yMove) > ySpeedMax) ){
				xAccel*=-1;
				yAccel*=-1;
			  }

			  if(Math.Abs(yMove)>ySpeedMax)yMove=ySpeedMax*(yMove/Math.Abs(yMove));

			  if(yMove>ySpeedMax)yMove=ySpeedMax;

			  if(catching){
				if(autoMove<0)autoMove=0;
				p.CatchLift(this);
			  }

			  if(autoMove>=0){
				x+=xMove;
				y+=yMove;
			  }

			double ST=manager.ScrollTop;
			double SL=manager.ScrollLeft;
			
			double VW=manager.VirtualWidth;
			double VH=manager.VirtualHeight;
			double SX=manager.ScrollXmax;
			double SY=manager.ScrollYmax;
			 switch(liftMode){
			  case liftUp:
			   if(ST >  y + charBodyHeight)
					y = ST + VH + charBodyHeight;
			  break;
			  case liftDown:
			   if(ST+VH <  y + charBodyHeight)
					y = (ST - charBodyHeight);
			  break;
			  case liftFall:
		//	   if(y > SY+VH)kill(KillMode.Drop);
			  break;
			  case liftRight:
			   if(x > SX+VW)x=0-charBodyWidth;
			  break;
			  case liftLeft:
			   if(x < 0-charBodyWidth)x=SX;
			  break;
			 }


			 return true;
		}
	//----------------------
		public override bool OnCollision(MCharacter obj){// sg
		 return false;
		}
	//----------------------
//		public void setAutoMove(int n){
//			autoMove=n;
//		}
		public int AutoMove{
			set{autoMove=value;}
		}

//		public double getFloorTop(){
//			return floorTop;
//		}
		public double FloorTop{
			get{return floorTop;}
		}
	//----------------------
		public override void SetSize(){
			SetSize(charSpriteWidth,charSpriteHeight);
		}
		public override void SetSize(int ww,int hh){
			sprite.SetSize(ww,hh);
			cSprX = ( charSpriteWidth  - charBodyWidth  ) / 2;
			cSprY = ( charSpriteHeight - charBodyHeight );
			floorTop    = (charBodyHeight-floorHeight)/2;
			floorBottom = floorTop + floorHeight;
		}


	}


}