namespace mylib
{
	using System.Drawing;
	using System.Drawing.Drawing2D;
	using System.Collections;

	using System;
	using mylib;

	public class MCharacter{
		protected double x=-500;
		protected double y=-500;
		protected double z= 103;
		 public virtual double X{
			get{	return x;}
			set{
				x=value;
				sprite.X=x-cSprX;
			   }
		 }
		 public virtual double Y{
			get{	return y;}
			set{
				y=value;
				sprite.Y=y-cSprY;
			   }
		 }
		 public virtual double Z{
			get{	return z;}
			set{	
				z=value;
				sprite.Z=z;
			}
		 }

		protected int life=0;
		 public virtual int Life{
			get {return life;}
		 }
		protected int alive=0;
		 public virtual int Alive{
			get {return alive;}
		 }
		
		protected int score=100;
		 public virtual int Score{
			get {return score;}
		 }
		protected bool peta=false;
		 public bool Peta{get{return peta;}}

		protected double oldX;
		protected double oldY;
		
		protected int innerTimer=0;
		 public int InnerTimer{
			get{return innerTimer;}
		 }

		protected int vFace=0;
		 public int VFace{
			get {return vFace;}
			set {
				vFace=value;
				sprite.FlipV=(vFace<0);
			}
		 }
		protected int hFace=1;
		 public int HFace{
			get {return hFace;}
			set {
				hFace=value;
				sprite.FlipH=(hFace<0);
			}
		 }


		protected double xMove=-2;
		protected double xAccel =3;
		protected double xSpeedMax=6;
		protected double xSpeedMin=.9;
		 public double XMove{
			get{return xMove;}
			set{xMove=value;}
		 }
		 public double XAccel{
			get{return xAccel;}
			set{xAccel=value;}
		 }
/*
		 public double XSpeedMax{
			get{return xSpeedMax;}
			set{xSpeedMax=value;}
		 }
		 public double XSpeedMin{
			get{return xSpeedMin;}
			set{xSpeedMin=value;}
		 }
*/		
		protected double yMove=0;
		protected double yAccel=6;
//		protected double yDropSpeed=0;
//		protected double yDropSpeedMax=15;
		protected double ySpeedMax=6;
		protected double ySpeedMin=6;

		protected double yJump    =0;
		protected double yBounce  =22.5;
		
		 public double YMove{
			get{return yMove;}
			set{yMove=value;}
		 }
		 public double YAccel{
			get{return yAccel;}
			set{yAccel=value;}
		 }
		 public double YSpeedMax{
			get{return ySpeedMax;}
			set{ySpeedMax=value;}
		 }
		 public double YSpeedMin{
			get{return ySpeedMin;}
			set{ySpeedMin=value;}
		 }
		 public double YJump{
			get{return yJump;}
			set{yJump=value;}
		 }

		protected bool checkStage= true;  // wĩIuWFNgƂ̔邩ǂ
		protected bool checkFloor= false; // ̒[Ń^[邩
		protected bool checkWall = true;  // ǂ𖳎邩
		protected bool hasGroupCollision=true; // mŏՓ˔肷邩
		 public virtual bool HasGroupCollision{
			get{return hasGroupCollision;}
		 }
		protected bool screenDrop=false; // ʊOɏo_ŎSƂ
		 public bool ScreenDrop{
			set{screenDrop=value;}
		 }
		protected bool yDropKill=true; //_ŎSƂ邩
		protected bool fire=false;
		 public virtual bool Fire{
			get{return fire;}
		 }
		protected bool star=false;
		 public virtual bool Star{
			get{return star;}
		 }
		protected bool ghost=false;
		 public virtual bool Ghost{
			get{return ghost;}
		 }


		protected int charBodyWidth   = 24;
		protected int charBodyHeight  = 24;
		protected int charSpriteWidth = 32;
		protected int charSpriteHeight= 32;
		protected int cSprX=4;
		protected int cSprY=7;
		 public int Width{
			get {return charBodyWidth;}
		 }
		 public int Height{
			get {return charBodyHeight;}
		 }
		 public int SpriteWidth{
			get {return charSpriteWidth;}
		 }
		 public int SpriteHeight{
			get {return charSpriteHeight;}
		 }

//		 protected const int alignBottom=1;
//		 protected const int alignMiddle=0;
		 protected enum Valign{Bottom,Middle,Top};
		private Valign vAlign=Valign.Bottom;
		 protected Valign verticalAlign{
			get{	return vAlign;}
			set{
				vAlign=value;
				SetSize();
			}
		 }
		
		protected int registFire  = -1; //
		protected int registUpper = -1; //
		protected int registKick  = -1; //
		protected int registPress = -1; //

		protected int charCode=0;
		 public int Code{
			get{return charCode;}
		 }

		protected int imgDie=0;
		 public int ImgDie{get{return imgDie;}}
		protected int imgWalk=0;
		 public int ImgWalk{get{return imgWalk;}}
		protected int imgStand=0;
		 public int ImgStand{get{return imgStand;}}
		
		protected MCharacter master;
		protected ObjGroup myGroup;
		 public ObjGroup Group{get{return myGroup;}}
		
		protected Sprite sprite;// = new Sprite(x,y,z);
		 public virtual Sprite Sprite{
			get{return sprite;}
		 }
		
		protected bool visible=false;
		 public virtual bool Visible{
			get{return visible;}
			set{
				visible=value;
				sprite.Visible=visible;
			}
		 }

		private int face=0;
		 public int Face{
			get{return face;}
			set{
			  if(face!=value)
			    sprite.BitmapID=value;
			   if(imgWalk==0)imgWalk=value;
			  face=value;
			}
		 }

		protected Mind mind=mylib.Mind.Other;
		 public virtual mylib.Mind Mind{
			get{return mind;}
		 }

		protected int id=0;
		 public virtual int ID{
			get{return id;}
		 }
		protected static int idCnt=0;
		

		protected StageManager manager;

		public MCharacter(){}

		public MCharacter(StageManager E,double xx,double yy)
			:this(E,xx,yy,0,0)
		{
		}

		public MCharacter(StageManager E,double xx,double yy,int code)
			:this(E,xx,yy,code,0)
		{
		}

		public MCharacter(StageManager E,double xx,double yy,int code,int option)
		{
			manager=E;
			alive=1;
			id=idCnt++;
			charCode=code;
			sprite=new Sprite();
			SetSize();
			Visible=true;
			MoveTo(xx,yy,Zindex.BasicZ);


			init(x,y,option);
		}

		protected virtual void init(double xx,double yy,int option){
		}

	//----------------------
		public virtual bool DrawEntry(){
			if(!visible)return false;
			if(alive<0)return false;
			if(manager.CheckScreen(this) < 0)return false;
			sprite.FlipH=(hFace<0);
			MoveTo(x,y);
			//if(face!=0)sprite.setBitmap(face);
			//sprite.moveTo(x-cSprX,y-cSprY,z);
		 return sprite.DrawEntry();
		}
	//----------------------
		public virtual bool Action(){
		 if(alive<0)return false;
		  innerTimer++;
		  if(basicMove()<0)return false;
		 return true;
		}
	//----------------------
		public virtual bool Collision(MCharacter m){
		 if(m==this)return false;
		 if(alive<0)return false;
		 return basicCollision(m);
		}
		public virtual bool Collision(double xx,double yy,double ww,double hh){
		 if(alive<0)return false;
		 return basicCollision(xx,yy,ww,hh);
		}
	//----------------------
		public virtual bool OnCollision(MCharacter obj){
		 if(alive<0)return false;
		 return true;
		}
	//----------------------
		public virtual int Kill(){
			return Kill(KillMode.Other);
		}
		public virtual int Kill(KillMode Kmode){
			if(alive<0)return -1;

			alive=-1;
			if(sprite!=null)sprite.Kill();
			sprite=null;
			master=null;
	//		if(myGroup!=null)myGroup.Remove(this);
	//		myGroup=null;
			manager=null;
			return -1;

		}
	//----------------------
		public virtual int GetBonus(int s){
			if(master != null)return master.GetBonus(s);
			return 0;
		}
	//----------------------
		public virtual int GetKickBonus(){
			if(master != null)return master.GetKickBonus();
			return 0;
		}
	//----------------------
		public virtual int GetStarBonus(){
			if(master != null)return master.GetStarBonus();
			return 0;
		}
	//----------------------
		public virtual int GetScore(int s){
			if(master != null)return master.GetScore(s);
			return s;
		}
	//----------------------
		public virtual void GetItem(int s){
			if(master != null)master.GetScore(s);
		}
	//----------------------
		public virtual int StepEnemy(MCharacter m){
			if(master != null)return master.StepEnemy(m);
			return 0;
		}
	//----------------------
		public virtual int Damage(MCharacter m){// throws GameException{
			return life;
		}
	//----------------------
		public MCharacter GroupEntry(ObjGroup grp){
			grp.Add(this);
			return this;
		}
		public ObjGroup SetGroup(ObjGroup obj){
			myGroup=obj;
			return myGroup;
		}
	//----------------------
		public virtual void SetMaster(MCharacter m){
			master=m;
		}
	//----------------------
		private bool basicCollision(MCharacter m){
			if(m==this)return false;
			bool b=basicCollision(m.X,m.Y,m.Width,m.Height);
			return b;
		}
	//----------------------
		private bool basicCollision(double xx,double yy,double ww,double hh){
			if(alive<0)return false;
			if(x+charBodyWidth  < xx    )return false;
			if(y+charBodyHeight < yy    )return false;
			if(x        > xx+ww ) return false;
			if(y        > yy+hh ) return false;
			
			return true;
		}
		
		protected virtual bool stepCollision(MCharacter m){
		 if(m is Player ){
			if(((Player)m).ActionMode == ActionMode.Swim)return false;
		 }

		  double mF =m.Y+m.Height;
		  double eF =  y+  charBodyHeight;
		  double mC =m.X+m.Width/2;
		 if(m.YMove - m.YMove >= 16)return true;	// Ηx
		 if(mF < eF && m.yMove>10)return true;
		 if(m.yMove==0 && mF > eF)return false;
		 if(y+charBodyHeight*.8 > mF)return true;
		 if(m.YMove>10 && mC > x && mC < x+charBodyWidth)return true;
		 if(eF <= mF)return false;
		 return true;
		}

	
		public virtual void SetSize(){
			SetSize(charSpriteWidth,charSpriteHeight);
		}
		public virtual void SetSize(int ww,int hh){
			sprite.SetSize(ww,hh);
			cSprX=(ww-charBodyWidth)/2;
			cSprY=(hh-charBodyHeight);

			if(verticalAlign== Valign.Middle)cSprY/=2;
			else
			if(verticalAlign== Valign.Bottom)cSprY-=1;
		}
		public virtual void SetSize(int ww,int hh,int www,int hhh){
			charBodyWidth=www;
			charBodyHeight=hhh;
			SetSize(ww,hh);
		}

		public virtual void MoveTo(double xx,double yy){
			MoveTo(xx,yy,z);
		}
		public virtual void MoveTo(double xx,double yy,double zz){
			x=xx;y=yy;z=zz;
			sprite.MoveTo(x-cSprX,y-cSprY,z);
		}
		public virtual void MoveBy(double xx,double yy){
			x+=xx;y+=yy;
			sprite.MoveTo(x-cSprX,y-cSprY);
		}
		public virtual void MoveBy(double xx,double yy,double zz){
			x+=xx;y+=yy;z+=zz;
			sprite.MoveTo(x-cSprX,y-cSprY,z);
		}





		protected virtual int getImageID(string str){
			return manager.GetImageID(str);
		}
		
		protected virtual Image getImageData(int ID){
			return manager.GetImageData(ID);
		}





	//----------------------
		protected int basicMove(){
			oldX=x;
			oldY=y;
		// ------------
			if(yMove==0 && yJump!=0){
				yMove=-yJump;
			}else{
				yMove+=yAccel;
				if(yMove>ySpeedMax)yMove=ySpeedMax;
			}
		// ------------>

		//---------------
		 if(checkStage==true){
		if(yMove>0){ //
		 double flPoint=y+charBodyHeight+yMove;
		 int floor=manager.GetXYPointObject(x+charBodyWidth*.5,flPoint);
		  if(manager.CheckFloorBlock(floor) > 0){
			 y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
			 yMove=0;
		  }

		}

		 if(checkWall==true){
		  if(xMove>0){
		   double blPoint=x+charBodyWidth+xMove/2;
		   int blockR=manager.GetXYPointObject(blPoint,y+charBodyHeight*.5);
			if(manager.CheckWallBlock(blockR) > 0){
			 x=Math.Floor(blPoint/manager.BlockWidth)*manager.BlockWidth-charBodyWidth;
			 xMove*=-1;
			}
		  }
		  else 
		  if(xMove<0)
		  {
		   double blPoint=x+xMove/2;
		   int blockL=manager.GetXYPointObject(blPoint,y+charBodyHeight*.5);
			if(manager.CheckWallBlock(blockL) > 0){
			 x=Math.Floor(blPoint/manager.BlockWidth + 1)*manager.BlockWidth;
			 xMove*=-1;
			}
		  }
		 }
		
		 if(checkFloor==true && yMove==0){
		  if(xMove>0){
		   double blPoint=x+charBodyWidth+xMove;
		   int blockR=manager.GetXYPointObject(blPoint,y+charBodyHeight);
			if(manager.CheckFloorBlock(blockR) < 0){
			 x=Math.Floor(blPoint/manager.BlockWidth)*manager.BlockWidth-charBodyWidth/2;
			 xMove*=-1;
			}
		  }
		  else 
		  if(xMove<0)
		  {
		   double blPoint=x+xMove;
		   int blockL=manager.GetXYPointObject(blPoint,y+charBodyHeight);
			if(manager.CheckFloorBlock(blockL) < 0){
			 x=Math.Floor(blPoint/manager.BlockWidth+1)*manager.BlockWidth+charBodyWidth/2;
			 xMove*=-1;
			}
		  }
		 }
		}

		x+=xMove;
		y+=yMove;
		
		if(xMove!=0)hFace=(int)Math.Floor(xMove/Math.Abs(xMove));

		 return 1;
		//---------------
		}


	}
}