namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
	
	class MonsterFlower: Chubo{
		private double topY;
		private double bottomY;
		private int animateCounter;
		private const int animax=50;
		private int waitTop=EnemyParameter.MFlowerWaitTop;
		private bool ignoreTouch=false;

		public MonsterFlower(StageManager E,double xx,double yy,int code,int option)
			:base(E,xx,yy,code,option){
		}


		protected override void init(double xx,double yy,int option){
			xMove = 0;
			yMove = 1.5;
			
			string iWalk,iDie;
			if(charCode==mylib.CharCode.PakkunRD){
				yMove*=2;
				waitTop/=2;
				ignoreTouch=true;
				iWalk = EnemyParameter.MFlowerRD_imgWalk;
				iDie  = EnemyParameter.MFlowerRD_imgDie;
			}else{
				iWalk = EnemyParameter.MFlowerGR_imgWalk;
				iDie  = EnemyParameter.MFlowerGR_imgDie;
			}

			score=800;
			animateCounter=-manager.M(20);
			
			imgWalk  = getImageID(iWalk);
			imgDie   = getImageID(iDie);
			Face=imgWalk;
			
			registFire  = -1; //
			registUpper = -1; //
			registKick  = -1; //
			registPress =  1; //
			hasGroupCollision = false;

			charBodyWidth    = 24;
			charBodyHeight   = 24;
			charSpriteWidth  = 32;
			charSpriteHeight = 48;


			x=Math.Floor(xx/manager.BlockWidth ) * manager.BlockWidth-manager.BlockWidth/2;
			y=Math.Floor(yy/manager.BlockHeight) * manager.BlockHeight+manager.BlockHeight-charBodyHeight;
			topY=y+2;
			y+=manager.BlockHeight * 2;
			bottomY=y;

			Z=Zindex.StageZ-1;

			x+=cSprX;
			SetSize();
		}

	//----------------------
		public override bool Action(){
		  if(alive<0)return false;
		  if(manager.CheckScreen(this)< 0)return false;
		 innerTimer++;

		  bool touch=false;
			Player p=manager.GetPlayerObject(0);
			double pl=p.X,pr=p.X+p.Width;
			double dp=manager.BlockWidth-charBodyWidth / 2  + 3;

			// yǖ
			if(pr > x-dp && pl < x+charBodyWidth+dp)touch=true;


		  if(animateCounter <= 0){
			if(touch && !ignoreTouch)animateCounter--;
		  }else
		  if(animateCounter < animax){
			y-=yMove;
			if(y < topY){
				y=topY;
				animateCounter=animax-1;
			}
		  }else
		  if(animateCounter < animax + waitTop){
		  }else{
			y += yMove;
			if(y > bottomY){
				y = bottomY;
				animateCounter =- (manager.M(waitTop))-10;
			}
		  }

		  animateCounter++;
			 return true;
		} //


	//----------------------
		public override bool OnCollision(MCharacter obj){
		 if(alive<0)return false;
		 if(obj.Alive<0)return false;
		 if(manager.CheckScreen(this) < 0)return false;
		  if(y>=topY+charBodyHeight)return false; // Ă鎞͔𖳎
		  switch(obj.Mind){
			case mylib.Mind.Kick:
			 obj.GetKickBonus();
			 Kill(KillMode.Kick);
			break;
			case mylib.Mind.Fire:
			 obj.GetScore(score);
			 Kill(KillMode.Fire);
			break;
			case mylib.Mind.Player:
			if(((Player)obj).Star == true){
				obj.GetStarBonus();
				obj.GetScore(score);
				Kill(KillMode.Star);
			}else{
				obj.Damage(this);
			}
			break;
		  }
		 return true;
		}




















	}
}