namespace mylib{
	using System;
	using System.Collections;
	using mylib;

	public class ObjGroup{
		private ArrayList vc;
		private ArrayList ret;
		private ArrayList tmp;
		
		private void InitBlock(){
			vc = new ArrayList();
			ret = new ArrayList();
			tmp = new ArrayList();
		}
		public ObjGroup(){
			InitBlock();
		}

		public  bool Add(MCharacter cc)
		{
			if (vc.Contains(cc))return false;
			vc.Add(cc);
			cc.SetGroup(this);
			return true;
		}
		public bool Remove(MCharacter cc)
		{
			if (!vc.Contains(cc))return false;
			vc.Remove(cc);
			return true;
		}

		public bool Clear()
		{
			for (IEnumerator e = vc.GetEnumerator(); e.MoveNext(); )
			{
				MCharacter cc = (MCharacter) e.Current;
				if (cc.Alive >= 0)cc.Kill();
			}
			vc.Clear();
			ret.Clear();
			tmp.Clear();
			return true;
		}

		public void  DrawEntry()
		{
			for (IEnumerator e = vc.GetEnumerator(); e.MoveNext(); )
			{
				MCharacter cc = (MCharacter) e.Current;
				if (cc.Alive > 0)
					cc.DrawEntry();
			}
		}

		public void check(){
			foreach(object o in tmp){
				if(vc.Contains(o))vc.Remove(o);
			}
			tmp.Clear();
		}



		
		public void  Action()
		{
//		int vccnt=vc.Count;
			try{
//			 foreach (object e in vc )
//			 {
			 for(int i=0;i<vc.Count;i++){
				MCharacter cc = (MCharacter) vc[i];
				if (cc.Alive < 0)
				{
					tmp.Add(cc);
				}
				else{
					if( cc.Action() && cc.HasGroupCollision){
						GroupCollision(cc);
					}
				}
			 }
			}catch(Exception ex){
				Console.WriteLine("Exception in ObjGroup.Action:"+ex);
			}
			check();
		}
		public ArrayList Collision(MCharacter m)
		{
			ret.Clear();
			for (IEnumerator e = vc.GetEnumerator(); e.MoveNext(); )
			{
				MCharacter cc = (MCharacter) e.Current;
				if (cc == m)
					continue;
				if (cc.Alive < 0)
					continue;
				if (cc.Collision(m))
				{
					ret.Add(cc);
				}
			}
			return ret;
		}
		
		public ArrayList GroupCollision(MCharacter m)
		{
			ArrayList v = Collision(m);
			for (IEnumerator e = v.GetEnumerator(); e.MoveNext(); )
			{
				MCharacter cc = (MCharacter) e.Current;
				if (cc == m)
					continue;
				cc.OnCollision(m);
				m.OnCollision(cc);
			}
			return v;
		}
		

		private void DBG(string str)
		{
			System.Console.Out.WriteLine(str);
		}

	}
}