namespace mylib
{
	using System;
	using System.Drawing;
	using System.Drawing.Drawing2D;
	using mylib;


	public class PixelEffector{
	 private int w=640;
	 private int h=480;

	 private Image img;
	 private Image buf;
	 private Graphics gt;
	 private GraphicsUnit unit=GraphicsUnit.Pixel;
	 
	 private Rectangle rect1 = new Rectangle(0,0,0,0);
	 private Rectangle rect2 = new Rectangle(0,0,0,0);
	 private Rectangle rect3 = new Rectangle(0,0,0,0);
	 
	 
	 private ScreenManager manager;
	 public PixelEffector(ScreenManager m,Image I){
		manager=m;
		SetBuffer(I);
	 }
	 public bool SetBuffer(Image I){
	  try{
		w=I.Width;
		h=I.Height;
		img=I;

		 rect3.X=(int)Math.Round(manager.ScreenWidth/2);
		 rect3.Y=(int)Math.Round(manager.ScreenHeight/2);
		 rect3.Width	= (int)Math.Round(manager.ScreenWidth);
		 rect3.Height	= (int)Math.Round(manager.ScreenHeight);
		if(buf==null)buf=new Bitmap(w,h);
		gt=Graphics.FromImage(buf);
		gt.InterpolationMode = InterpolationMode.NearestNeighbor;
		gt.SmoothingMode = SmoothingMode.None;
		return true;

	  }catch(Exception e){
		manager.DBG("Exception PixelEffector.SetBuffer"+e);
		return false;
	  }
	 }

	 public void Draw(Graphics g,int x2 ,int y2,int x3 , int y3){
		if(manager.Mozaic>1){
		double	mozaic=manager.Mozaic;
		 int ww=(int)Math.Round(w/mozaic);
		 int hh=(int)Math.Round(h/mozaic);


		 rect1.X	= x2;
		 rect1.Y	= y2;
		 rect1.Width	= x3;
		 rect1.Height	= y3;
		 rect2.Width	= ww;
		 rect2.Height	= hh;

		 gt.DrawImage(img,rect2,rect3,unit);
		 g.DrawImage(buf,rect1,rect2,unit);

//		 gt.DrawImage(img,0,0,ww,hh);
//		 g.DrawImage(buf,x2,y2,x3+x2,y3+y2,rect2);
 
		}else{
		 rect1.X	= x2;
		 rect1.Y	= y2;
		 rect1.Width	= x3;
		 rect1.Height	= y3;
//		 g.DrawImage(img,x2,y2,x3,y3);
		 g.DrawImage(img,rect1,rect3,unit);
		}
	 }

	}

}