namespace mylib
{
	using System.Drawing;
	using System.Drawing.Drawing2D;
	using System.Collections;

	using System;
	using mylib;
	
	public delegate void PlayerDamageHandler(int damage,MCharacter m);

	public class Player : MCharacter{
		public event PlayerDamageHandler PlayerDamage;

		private int mode=PlayerMode.Normal;
		 public int Mode{
			get {return mode;}
		 }

		private ActionMode actionMode=ActionMode.Run;
		 public ActionMode ActionMode{
			get{return actionMode;}
			set{actionMode=value;}
		 }

		private bool animateFlag=false;
		 public bool Animate{
			get{return animateFlag;}
		 }
		private int animateMode=0;
		private int animateCounter=0;

		private int ghostTimer=0;
		private int ghostTimerLength=30*3;

		private int starTimer=0;
		private int starTimerLength=30*8;
		private int starBonus=0;

		private bool fireFlag=false;
		public bool jumpFlag=false;
		 private int stepCnt=0;
		  public int StepCnt{
			get{return stepCnt;}
		  }
		 private int jumpBonus=0;
		 private int kickBonus=0;
		private bool climbFlag=false;
		private bool sitdown=false;
		 public bool Sitdown{
			get{return sitdown;}
		 }


		private int coin=0;
		 public int Coin{
			get{return coin;}
		 }

		private int warpID=-1;


		private FireballGroup fireball;


	//	public double xMove=0;
//		private double xSpeedMax=4;
		private double xSpeedMaxTurbo=11;
//		private double xSpeedMin=.3;
		private double xBrakeSlow = .88;
		private double xBrakeQuick=.6;
		private double xBrakeSliding = .93;
//		private double xAccel=.4;
		private double xAccelTurbo=.8;
		private double xBounce=0;
	//	public double yMove=0;
//		private double yAccel=3;
//		private double ySpeedMax=20;
//		private double yJump    =26.6;//26.7;
		private double yJumpHigh=32.1;//31.98;
		private double yJumpSpeeddown=.6;
//		private double yBounce=-.3;
		private double yClimbSpeed=4;
		
		
		private double xCameraControl=0;
		 public double XCameraControl{
			get{return xCameraControl;}
			set{xCameraControl=value;}
		 }
		private double yCameraControl=0;
		 public double YCameraControl{
			get{return yCameraControl;}
			set{yCameraControl=value;}
		 }



		 private double xSpeedMaxSwim=6;
		 private double yJumpSwim=9.01;
		 private double yAccelSwim=1;
		 private double ySpeedMaxSwim=8;
		
		 private int charSmallHeight = 24;
		 private int charSmallSpriteHeight=32;
		 private int charBigHeight = 48;
		 private int charBigSpriteHeight=56;


		private GamePad myPad;
		 public GamePad GamePad{
			get{return myPad;}
			set{myPad=value;}
		 }
		
		 private int imgRun;
		 private int imgJump;
		 private int imgBrake;
		 private int imgFire;
		 private int imgSit;
		 private int imgBar;
		
		 private int imgClimb;
		 private int imgClimbMove;
		 private int imgSwim;
		 private int imgSwimMove;

		private ObjGroup enemy;

		private GameEventManager evManager;


		private void init(){
			xAccel=.4;
			xSpeedMin=.3;
			xSpeedMax= 4;

			yAccel=3;
			ySpeedMax=20;
			yJump    =26.6;

			charBodyWidth    = 24;
			charBodyHeight   = 24;
			charSpriteWidth  = 32;
			charSpriteHeight = 32;
			xMove=0;
			yMove=0;

			life=GameConfig.Life;
			score=0;

			imgStand = getImageID(PlayerMode.imgStand);
			imgWalk  = getImageID(PlayerMode.imgWalk);
			imgRun   = getImageID(PlayerMode.imgRun);
			imgJump  = getImageID(PlayerMode.imgJump);
			imgBrake = getImageID(PlayerMode.imgBrake);
			imgDie   = getImageID(PlayerMode.imgDie);
			imgFire  = getImageID(PlayerMode.imgFire);
			imgSit   = getImageID(PlayerMode.imgSit);

			imgClimb     = getImageID(PlayerMode.imgClimb);
			imgClimbMove = getImageID(PlayerMode.imgClimbMove);
			imgSwim      = getImageID(PlayerMode.imgSwim);
			imgSwimMove  = getImageID(PlayerMode.imgSwimMove);

			imgBar   = getImageID(PlayerMode.imgBar);


			Visible=true;
			SetSize();
			Face=imgStand;
		}

//-------------------------
		public Player(StageManager E,GameEventManager EV,double xx,double yy,GamePad PAD){
			manager=E;
			evManager=EV;
			myPad=PAD;
			alive=1;
			x=xx;
			y=yy;
			z=Zindex.PlayerZ;
			mind=mylib.Mind.Player;
			sprite=new Sprite();
			init();

			
			fireball=new FireballGroup(this,manager);

		}

		public void Reset(){
			Reset(1);
		}
		public void Reset(int all){
			x=0;y=0;z=Zindex.PlayerZ;
			xMove=0;xCameraControl=0;
			yMove=0;yCameraControl=0;
			star    = false;
			ghost   = false;
			fireFlag= false;
			jumpFlag= false;
			stepCnt = 0;
			jumpBonus = 0;
			starBonus = 0;
			kickBonus = 0;
			climbFlag = false;
			sitdown   = false;
			animateFlag    = false;
			animateCounter = 0;
			Face=imgStand;


			ghostTimer = 0;
			starTimer  = 0;
			sprite.Opacity= 1;
			SetSize();
			fireball.Kill();

			if(all>0){
				fireball.Reset();
				score = 0;
				coin  = 0;
				life  = GameConfig.Life;
				fire  = false;
			//	SetMode(PlayerMode.Normal,false);
			}
		}

		public void SetEnemyGroup(ObjGroup o){
			enemy=o;
			fireball.Enemy=o;
			
		}
		public ObjGroup GetEnemy(){
			return enemy;
		}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
		public override bool Action(){
		 innerTimer++;
		  xCameraControl=0;
		  yCameraControl=0;

		 bool rt=false;
		  switch(actionMode){
			default:
				rt=actionRun();
			break;
			case ActionMode.Run:
				rt=actionRun();
			break;
			case ActionMode.Swim:
				rt=actionSwim();
			break;
			case ActionMode.Fly:
				rt=actionSwim();
			break;
		  }

		  fireball.Action();

		  if(--ghostTimer==0)SetMode(PlayerMode.NGhost,false);
		  if(--starTimer==0)SetMode(PlayerMode.NStar,false);
		  else
		  if(starTimer>0){
		   if(starTimer<=30 && starTimer%6==0){
			MCharacter m=manager.CreateMessage(""+(starTimer/6),x+manager.BlockWidth,y);
		   }
			MCharacter m2=manager.CreateEffect(mylib.CharCode.DustEffect,x+manager.M(charBodyWidth),y+manager.M(charBodyHeight),0);
			
		  }
		  xCameraControl += xMove;
		  yCameraControl += yMove;
		  return rt;
		}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
		public bool actionRun(){
			oldX=x;
			oldY=y;


			if(stepCnt==10000){ // Ȃɂ𓥂݂tO
			 yMove=-23.1;
			 if(myPad.ButtonA==1)yMove=-40.2;
			 stepCnt=3;
			 jumpFlag=true;
			}
			
				// Ⴊ
			  if(mode!=PlayerMode.Normal && yMove == 0){
				if(myPad.Y>0 && !climbFlag){ // Ⴊ
					charBodyHeight=charSmallHeight;
					charSpriteHeight=charSmallSpriteHeight;
					if(!sitdown){
						y+=(charBigHeight-charSmallHeight);
						SetSize();
					}
					sitdown=true;
				}else
				if(myPad.Y<=0 || climbFlag){ //
					charBodyHeight=charBigHeight;
					charSpriteHeight=charBigSpriteHeight;
					if(sitdown){
						y-=(charBigHeight-charSmallHeight);
						SetSize();
					}
					sitdown=false;
				}
			 }
				// Ⴊ-->

			// Eړ
				double xAccelT=xAccel;
				 if(yMove!=0)xAccelT*=.8;
				 else 
				 if(myPad.ButtonB==1)xAccelT=xAccelTurbo;

				double xMoveABS=Math.Abs(xMove);
				if(yMove==0 && myPad.X==0){
				   if(!sitdown)
					xMove*= xBrakeSlow; 
				   else
					xMove*= xBrakeSliding; 
				 if(Math.Abs(xMove)<=xSpeedMin)xMove=myPad.X;
				}else
				if(yMove==0 && sitdown){
					xMove*= xBrakeSliding; 
				}else{
				  double mp=xMove*myPad.X;
				  if(mp > 0)xMove += xAccelT*(xMove/xMoveABS);
				  else
				  if(mp < 0)xMove *= xBrakeQuick;
				  else
				  if(mp==0)xMove*=xBrakeSlow;


				xMoveABS=Math.Abs(xMove);
				   if(xMoveABS > xSpeedMaxTurbo -1)
					xMove=xSpeedMaxTurbo*(xMove/xMoveABS);
				  if(myPad.ButtonB!=1){
				xMoveABS=Math.Abs(xMove);
				   if(xMoveABS > xSpeedMax){
					xMove*=xBrakeSlow;
					xMoveABS=Math.Abs(xMove);
				   }
				  }
				 if(Math.Abs(xMove)<=xSpeedMin)xMove=xSpeedMin*myPad.X;
				}
			// Eړ܂


	//n`
			// ƃWv------------(ɗĂ)
			if(climbFlag){ //c^
			 yMove=0;
			  yMove=myPad.Y*yClimbSpeed;
			 if(myPad.ButtonA == 1){
				climbFlag=false;
				jumpFlag=false;
			 }
			}

			if(!climbFlag){
			 if(myPad.ButtonA == 1 && !jumpFlag && yMove==0){
			  if(Math.Abs(xMove)>=xSpeedMaxTurbo-.5)
				yMove=-yJumpHigh;
			   else
			  if(Math.Abs(xMove)>=xSpeedMaxTurbo-1)
				yMove=-(yJumpHigh+yJump)/2;
			  else
				yMove=-yJump;
			  jumpFlag=true;
			 }else{
			  if( myPad.ButtonA < 1 && yMove < 0 && stepCnt<=0)yMove*=yJumpSpeeddown;

			  yMove+=yAccel;
			  if(yMove>ySpeedMax)yMove=ySpeedMax;
			 }
			}

			// ------------>

			if(yMove>0){ //
			 double flPoint= y+charBodyHeight+yMove;
			 int floorL = manager.GetXYPointObject(x,flPoint);
			 int floorR = manager.GetXYPointObject(x+charBodyWidth-1,flPoint);
			  if(manager.CheckFloorBlock(floorL) > 0 || manager.CheckFloorBlock(floorR) > 0){
				jumpBonus=0;
				if(Math.Floor(flPoint/manager.BlockHeight)!=Math.Floor(y/manager.BlockHeight)){
				 y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
				 yMove=0;
				 if(myPad.ButtonA==0)jumpFlag=false;
				}
			  }
			}else
			if(yMove < 0){
			 double flPoint=y+yMove/2;
			 int blockHead=manager.GetXYPointObject(x+charBodyWidth/2,flPoint);
			  if(manager.CheckUpperBlock(blockHead) > 0){
				y=Math.Floor(flPoint/manager.BlockHeight + 1)*manager.BlockHeight;
				yMove=0.1;
				evManager.EventUpper(this,blockHead,x+charBodyWidth/2,flPoint);
			  }
			}else{
			}


		   if(charBodyHeight<manager.BlockHeight){//`r
			int blockP =manager.GetXYPointObject(x+charBodyWidth/2,y+charBodyHeight/2);
			int blockPL=manager.GetXYPointObject(x+1,y+charBodyHeight*.3);
			int blockPR=manager.GetXYPointObject(x+charBodyWidth-1,y+charBodyHeight*.3);


				int bp =manager.CheckWallBlock(blockP);
				int bpl=manager.CheckWallBlock(blockPL);
				int bpr=manager.CheckWallBlock(blockPR);
			if(bpl > 0 && bpr < 0){ // ߂肱
				 x=Math.Ceiling(Math.Floor(x/manager.BlockWidth + 1)*manager.BlockWidth);
				 if(xMove<0)xMove=0;
			}
			else 
			if(bpl < 0 && bpr > 0){ //E߂肱
				 x=Math.Floor(Math.Floor(x/manager.BlockWidth + 1)*manager.BlockWidth-charBodyWidth);
				 if(xMove>0)xMove=0;
			}else
			if(bp>0){ // S߂肱 (ƔΕɉo)
				xMove=0;x-=3*hFace;
			}

			 if(bp!=-3)climbFlag=false;
			else
			if(myPad.Y < 0){ // c^ & o[
				climbFlag=true;
				xMove=0;
				//jumpBonus=0;
			 }


			if(blockP>0){ // wĩIuWFNg`FbN
			 int p=manager.CheckEventBlock(blockP);
			 if(p==99)throw new GameException(GameException.Goal,blockP);
			  else
			 if(p>0)evManager.EventEventBlock(this,blockP);
			}


			//RC
			bool coinflag=false;// QdQbgȂ߂̃tO
			if(blockPL > 0){
			  int c=manager.CheckCoin(blockPL);
			  if(c>0){
				 int ret=manager.SetXYPointObject(x+1,y+charBodyHeight*.3,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,x+1,y+charBodyHeight*.3,0);
				  coinflag=true;
			  }
			}
			if(!coinflag){
			  int c=manager.CheckCoin(blockPR);
			  if(c>0){
				  manager.SetXYPointObject(x+charBodyWidth-1,y+charBodyHeight*.3,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,x+charBodyWidth-1,y+charBodyHeight*.3,0);
			  }
			}
			//RC肱܂

			if(xMove>0){
			 double blPoint=x+charBodyWidth+xMove;
			 int blockR=manager.GetXYPointObject(blPoint,y+charBodyHeight*.7);
				if(manager.CheckWallBlock(blockR)>0){
				 x=Math.Floor(blPoint/manager.BlockWidth)*manager.BlockWidth-charBodyWidth;
				 xMove*=xBounce;
				}
			}
			else 
			if(xMove<0){
			 double blPoint=x+xMove;
			 int blockL=manager.GetXYPointObject(blPoint,y+charBodyHeight*.7);
				if(manager.CheckWallBlock(blockL)>0){
				 x=Math.Floor(blPoint/manager.BlockWidth + 1)*manager.BlockWidth;
				 xMove*=xBounce;
				}
			}

			}else{ // fJ
			   double blCenterX = x+charBodyWidth/2;
			   double blRightX  = x+charBodyWidth;
			   double blLeftX   = x;
			   double yyHead = y+charBodyHeight*.2;
			   double yyFoot = y+charBodyHeight*.75;
			    //
				int blockHP  = manager.GetXYPointObject(blCenterX,yyHead);
				int blockHPL = manager.GetXYPointObject(blLeftX  ,yyHead);
				int blockHPR = manager.GetXYPointObject(blRightX ,yyHead);
			    //
				int blockFP  = manager.GetXYPointObject(blCenterX,yyFoot);
				int blockFPL = manager.GetXYPointObject(blLeftX  ,yyFoot);
				int blockFPR = manager.GetXYPointObject(blRightX ,yyFoot);

				int bpH =manager.CheckWallBlock(blockHP);
				int bpF =manager.CheckWallBlock(blockFP);
				int bpHL=manager.CheckWallBlock(blockHPL);
				int bpHR=manager.CheckWallBlock(blockHPR);
				int bpFL=manager.CheckWallBlock(blockFPL);
				int bpFR=manager.CheckWallBlock(blockFPR);

				if( (bpHL > 0 || bpFL > 0) && (bpHR < 0 && bpFR < 0) ){ // ߂肱
					 x=Math.Ceiling(Math.Floor(x/manager.BlockWidth + 1)*manager.BlockWidth);
					 if(xMove<0)xMove=0;
				}
				else 
				if( (bpHL < 0 && bpFL < 0) && (bpHR > 0 || bpFR > 0) ){ //E߂肱
					 x=Math.Floor(Math.Floor(x/manager.BlockWidth + 1)*manager.BlockWidth-charBodyWidth);
					 if(xMove>0)xMove=0;
				}
				else
				if(bpH > 0 || bpF > 0){ // S߂肱 (ƔΕɉo)
					xMove=0;x-=3*hFace;
				}

				 if(bpH!=-3)climbFlag=false;
				 else
				 if( myPad.Y < 0){ // c^ & o[
					climbFlag=true;
					xMove=0;
					//jumpBonus=0;
				 }

				if(blockHP>0 || blockFP>0){
				 int p  = manager.CheckEventBlock(blockHP);
				 int p2 = manager.CheckEventBlock(blockFP);
				  int blockTMP=blockHP;
				 if(p2 > p){p=p2;blockTMP=blockFP;}

				 if(p  == 99)throw new GameException(GameException.Goal,blockHP);
				  else
				 if(p  >  0)evManager.EventEventBlock(this,blockTMP);
				}

			//RC擾
			bool coinflag=false;// QdQbgȂ߂̃tO
			  if(blockHPL > 0){
			   int c=manager.CheckCoin(blockHPL);
			   if(c>0){
				  manager.SetXYPointObject(blLeftX  ,yyHead,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,blLeftX,yyHead,0);
				  coinflag=true;
			   }
			  }//else
			  if(!coinflag && blockHPR > 0 ){
			   int c=manager.CheckCoin(blockHPR);
			   if(c>0){
				  manager.SetXYPointObject(blRightX ,yyHead,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,blRightX,yyHead,0);
				  coinflag=true;
			   }
			  }
			  if(!coinflag && blockFPL > 0){
			   int c=manager.CheckCoin(blockFPL);
			   if(c>0){
				  manager.SetXYPointObject(blLeftX  ,yyFoot,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,blLeftX,yyFoot,0);
				  coinflag=true;
			   }
			  }
			  if(!coinflag && blockFPR > 0){
			   int c=manager.CheckCoin(blockFPR);
			   if(c>0){
				  manager.SetXYPointObject(blRightX ,yyFoot,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,blRightX,yyFoot,0);				  
				  coinflag=true;
			   }
			  }
			//RC擾 ܂


			if(xMove>0){
			 double blPoint=x+charBodyWidth+xMove;
			 int blockHR=manager.GetXYPointObject(blPoint,yyHead);
			 int blockFR=manager.GetXYPointObject(blPoint,y+charBodyHeight*.85);
				if(manager.CheckWallBlock(blockHR) > 0 || manager.CheckWallBlock(blockFR) > 0){
				 x=Math.Floor(blPoint/manager.BlockWidth)*manager.BlockWidth-charBodyWidth;
				 xMove*=xBounce;
				}
			}
			else 
			if(xMove<0){
			 double blPoint=x+xMove;
			 int blockHL=manager.GetXYPointObject(blPoint,yyHead);
			 int blockFL=manager.GetXYPointObject(blPoint,y+charBodyHeight*.85);
				if(manager.CheckWallBlock(blockHL) > 0 || manager.CheckWallBlock(blockFL) > 0){
				 x=Math.Floor(blPoint/manager.BlockWidth + 1)*manager.BlockWidth;
				 xMove*=xBounce;
				}
			}

			}

				x+=xMove;
				y+=yMove;



			// ̌ --
			 int facetmp=Face;
			  if( (yMove <= yAccel && yMove >= 0 && !jumpFlag) || yMove==0){ // 󒆂ł͕]Ȃ
				if(myPad.X > 0)hFace=1;
				else if(myPad.X < 0)hFace=-1;
			  }

			  if(yMove < 0 && !sitdown){ //㏸
				facetmp=imgJump;
				Face=facetmp;
			  }else
			  if(yMove > yAccel){
				if(!sitdown)facetmp=imgJump;
				else facetmp=imgSit;
				Face=facetmp;
			  }
			  else {
				if(xMove * hFace < 0 )facetmp=imgBrake;
				else 
				if(Math.Abs(xMove)>=xSpeedMaxTurbo-1)facetmp=imgRun;
				else
				if(Math.Abs(xMove)>0)facetmp=imgWalk;
				else
				facetmp=imgStand;

				if(sitdown)facetmp=imgSit; // Ⴊł
				
				Face=facetmp;
			  }
			  if(climbFlag){
				Face=(yMove!=0)?imgClimbMove:imgClimb;
			  }else
			// ̌ -->

				Face=facetmp;
				sprite.FlipH=(hFace<0);

			// t@CA[
			if(fire && !sitdown){
			 if(myPad.ButtonB==1 && !fireFlag){
			  fireball.Call();fireFlag=true;
			 }
			 if(myPad.ButtonB==0)fireFlag=false;
			}


			 stepCnt--;

			if(x<manager.ScrollLeft){
				x=manager.ScrollLeft;
				if(xMove<0)xMove=0;
			}else
//			if(x>manager.StageWidth-charSpriteWidth){
			if(x>manager.ScrollLeft+manager.VirtualWidth-charSpriteWidth){
				x=manager.ScrollLeft+manager.VirtualWidth-charSpriteWidth;
				if(xMove>0)xMove=0;
			}




			if(y>manager.StageHeight+manager.BlockHeight){
				//y=0;manager.ScrollTop=0;
				//evManager.EventDie(this);
				Drop();
				//SetMode(PlayerMode.Drop,true);
			}

			
			return true;
		} // end actionRun


//-------------------------------

		private bool actionSwim(){
			oldX=x;
			oldY=y;

			if(stepCnt==10000){ // Ȃɂ𓥂݂tO
			 yMove=-23.1;
			 if(myPad.ButtonA==1)yMove=-40.2;
			 stepCnt=3;
			 jumpFlag=true;
			}

		  if(mode!=PlayerMode.Normal && yMove == 0){
			if(myPad.Y>0){ // Ⴊ
				charBodyHeight=charSmallHeight;
				if(charSpriteHeight == charBigSpriteHeight){
					charSpriteHeight=charSmallSpriteHeight;
					if(!sitdown)y+=(charBigHeight-charSmallHeight);
					SetSize();
				}
				sitdown=true;
			}else
			if(myPad.Y<=0){ //
				charBodyHeight=charBigHeight;
				if(charSpriteHeight != charBigSpriteHeight){
					y-=(charBigHeight-charSmallHeight);
					charSpriteHeight=charBigSpriteHeight;
					SetSize();
				}
				sitdown=false;
			}
		 }else{
		   if(mode!=PlayerMode.Normal){ //Ⴊ݉j
			if(myPad.Y>0){
			 if(charSpriteHeight != charBigSpriteHeight){
				charSpriteHeight=charBigSpriteHeight;
					SetSize();
			 }
			 }else
			 if(myPad.Y<=0){ //
				charBodyHeight=charBigHeight;
				if(sitdown){
					y-=(charBigHeight-charSmallHeight);
					sitdown=false;
				}
			 }
		   }
		 }
			// Ⴊ-->

		// Eړ
			double xAccelT=xAccel;
			 if(yMove!=0)xAccelT*=.5;
			double xMoveABS=Math.Abs(xMove);
			if(yMove==0 && myPad.X==0){
			   if(!sitdown)
				xMove*= xBrakeSlow; 
			   else
				xMove*= xBrakeSliding; 
			 if(Math.Abs(xMove)<=xSpeedMin)xMove=myPad.X;
			}else
			if(yMove==0 && sitdown){
				xMove*= xBrakeSliding; 
			}else{
			  if(xMove*myPad.X > 0)	xMove += xAccelT*(xMove/xMoveABS);
			  else			xMove *= xBrakeQuick;// Brake!


			xMoveABS=Math.Abs(xMove);
			   if(xMoveABS > xSpeedMaxSwim -2)
				xMove=xSpeedMaxSwim*(xMove/xMoveABS);
			 if(Math.Abs(xMove)<=xSpeedMin)xMove=myPad.X;
			}

		//*/

			// ƃWv------------(ɗĂ)

			 if(myPad.ButtonA == 1 && !jumpFlag){
				yMove=-yJumpSwim;
				jumpFlag=true;
			 }else{
				yMove+=yAccelSwim;
				if(yMove>ySpeedMaxSwim)yMove=ySpeedMaxSwim;
			 }

		// ------------>

			if(yMove>0){ //
			 double flPoint = y+charBodyHeight+yMove;
			 int floorL     = manager.GetXYPointObject(x,flPoint);
			 int floorR     = manager.GetXYPointObject(x+charBodyWidth-1,flPoint);
			  if(	manager.CheckFloorBlock(floorL) > 0 || 
			 	manager.CheckFloorBlock(floorR) > 0){
				jumpBonus=0;
				if(Math.Floor(flPoint/manager.BlockHeight)!=Math.Floor(y/manager.BlockHeight)){
				 y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
				 yMove=0;
				}
			  }

			}
			else
			if(yMove<0){ //㏸
			 double flPoint=y+yMove/2;
			 int blockHead=manager.GetXYPointObject(x+charBodyWidth/2,flPoint);
			  if(manager.CheckUpperBlock(blockHead) > 0){
				y=Math.Floor(flPoint/manager.BlockHeight + 1)*manager.BlockHeight;
				yMove=0.1;
			  }
			}
			else{
			}

		   if(charBodyHeight < manager.BlockHeight){//`r
			int blockP  = manager.GetXYPointObject(x+charBodyWidth/2,y+charBodyHeight/2);
			int blockPL = manager.GetXYPointObject(x+1,y+charBodyHeight*.3);
			int blockPR = manager.GetXYPointObject(x+charBodyWidth-1,y+charBodyHeight*.3);

			
				int bp =manager.CheckWallBlock(blockP);
				int bpl=manager.CheckWallBlock(blockPL);
				int bpr=manager.CheckWallBlock(blockPR);
			if(bpl > 0 && bpr < 0){ // ߂肱
				 x=Math.Floor(x/manager.BlockWidth + 1) * manager.BlockWidth ;
				 if(xMove<0)xMove=0;
			}
			else 
			if(bpl < 0 && bpr > 0){ //E߂肱
				 x=Math.Floor(x/manager.BlockWidth + 1)*manager.BlockWidth-charBodyWidth;
				 if(xMove>0)xMove=0;
			}else
			if(bp>0){ // S߂肱 (ƔΕɉo)
				xMove=0;x-=4*hFace;
			}

			int ws =manager.CheckWaterStream(blockP);
			if(ws>0){
			  switch(ws){
				case 1:
				 x-=2;
				 xCameraControl-=2;
				 break;
				case 2:
				 x+=2;
				 xCameraControl+=2;
				 break;
				case 3:
				 y+=3.5;
				 break;
			  }
			}


			if(blockP>0){ // wĩIuWFNg`FbN
			 int p=manager.CheckEventBlock(blockP);
			 if(p==99)throw new GameException(GameException.Goal,blockP);
			  else
			 if(p>0)evManager.EventEventBlock(this,blockP);
			}

			//RC
			bool coinflag=false;// QdQbgȂ߂̃tO
			if(blockPL > 0){
			  int c=manager.CheckCoin(blockPL);
			  if(c>0){
				 int ret=manager.SetXYPointObject(x+1,y+charBodyHeight*.3,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,x+1,y+charBodyHeight*.3,0);
				  coinflag=true;
			  }
			}
			if(!coinflag){
			  int c=manager.CheckCoin(blockPR);
			  if(c>0){
				  manager.SetXYPointObject(x+charBodyWidth-1,y+charBodyHeight*.3,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,x+charBodyWidth-1,y+charBodyHeight*.3,0);
			  }
			}
			//RC肱܂

/*			  int c=manager.CheckCoin(blockP);
			  if(c>0){
				  manager.SetXYPointObject(x+charBodyWidth/2,y+charBodyHeight/2,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(CharCode.BounceCoinEffect,x+charBodyWidth/2,y+charBodyHeight/2,0);
			  }
			 }
*/


			if(xMove>0){
			 double blPoint=x+charBodyWidth+xMove;
			 int blockR=manager.GetXYPointObject(blPoint,y+charBodyHeight*.7);
				if(manager.CheckWallBlock(blockR)>0){
				 x=Math.Floor(blPoint/manager.BlockWidth)*manager.BlockWidth-charBodyWidth;
				 xMove*=xBounce;
				}
			}
			else 
			if(xMove<0){
			 double blPoint = x+xMove;
			 int    blockL  = manager.GetXYPointObject(blPoint,y+charBodyHeight*.7);
				if(manager.CheckWallBlock(blockL)>0){
				 x=Math.Floor(blPoint/manager.BlockWidth + 1)*manager.BlockWidth;
				 xMove*=xBounce;
				}
			}
		 }else{ // X[p[[h
		   double blCenterX = x+charBodyWidth/2;
		   double blRightX  = x+charBodyWidth;
		   double blLeftX   = x;
		   double yyHead = y+charBodyHeight*.2;
		   double yyFoot = y+charBodyHeight*.75;
		    //
			int blockHP  = manager.GetXYPointObject(blCenterX,yyHead);
			int blockHPL = manager.GetXYPointObject(blLeftX  ,yyHead);
			int blockHPR = manager.GetXYPointObject(blRightX ,yyHead);
		    //
			int blockFP  = manager.GetXYPointObject(blCenterX,yyFoot);
			int blockFPL = manager.GetXYPointObject(blLeftX  ,yyFoot);
			int blockFPR = manager.GetXYPointObject(blRightX ,yyFoot);

			
			int bpH  = manager.CheckWallBlock(blockHP);
			int bpF  = manager.CheckWallBlock(blockFP);
			int bpHL = manager.CheckWallBlock(blockHPL);
			int bpHR = manager.CheckWallBlock(blockHPR);
			int bpFL = manager.CheckWallBlock(blockFPL);
			int bpFR = manager.CheckWallBlock(blockFPR);

			if( (bpHL > 0 || bpFL > 0) && (bpHR < 0 && bpFR < 0) ){ // ߂肱
				 x=Math.Floor(x/manager.BlockWidth + 1)*manager.BlockWidth;
				 if(xMove<0)xMove=0;
			}
			else 
			if( (bpHL < 0 && bpFL < 0) && (bpHR > 0 || bpFR > 0) ){ //E߂肱
				 x=Math.Floor(x/manager.BlockWidth + 1)*manager.BlockWidth-charBodyWidth;
				 if(xMove>0)xMove=0;
			}
			else
			if(bpH > 0 || bpF > 0){ // S߂肱 (ƔΕɉo)
				xMove=0;x-=4*hFace;
			}


			int ws =manager.CheckWaterStream(blockFP);
			if(ws>0){
			  switch(ws){
				case 1:
				 x-=2;
				 xCameraControl-=2;
				 break;
				case 2:
				 x+=2;
				 xCameraControl+=2;
				 break;
				case 3:
				 y+=3.5;
				 break;
			  }
			}


		
			if(blockHP>0 || blockFP>0){ // wĩRCȂǂ`FbN
			 int p  = manager.CheckEventBlock(blockHP);
			 int p2 = manager.CheckEventBlock(blockFP);
			  int blockTMP=blockHP;
			 if(p2 > p){p=p2;blockTMP=blockFP;}

			 if(p  == 99)throw new GameException(GameException.Goal,blockHP);
			 //evManager.EventGoalBlock( this,blockTMP);
			  else
			 if(p  >   0)evManager.EventEventBlock(this,blockTMP);
			 }


			//RC擾
			bool coinflag=false;// QdQbgȂ߂̃tO
			  if(blockHPL > 0){
			   int c=manager.CheckCoin(blockHPL);
			   if(c>0){
				  manager.SetXYPointObject(blLeftX  ,yyHead,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,blLeftX,yyHead,0);
				  coinflag=true;
			   }
			  }//else
			  if(!coinflag && blockHPR > 0 ){
			   int c=manager.CheckCoin(blockHPR);
			   if(c>0){
				  manager.SetXYPointObject(blRightX ,yyHead,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,blRightX,yyHead,0);
				  coinflag=true;
			   }
			  }
			  if(!coinflag && blockFPL > 0){
			   int c=manager.CheckCoin(blockFPL);
			   if(c>0){
				  manager.SetXYPointObject(blLeftX  ,yyFoot,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,blLeftX,yyFoot,0);
				  coinflag=true;
			   }
			  }
			  if(!coinflag && blockFPR > 0){
			   int c=manager.CheckCoin(blockFPR);
			   if(c>0){
				  manager.SetXYPointObject(blRightX ,yyFoot,0);
				  GetItem(ItemCode.Coin);
				  manager.CreateEffect(mylib.CharCode.BounceCoinEffect,blRightX,yyFoot,0);				  
				  coinflag=true;
			   }
			  }
			//RC擾 ܂






			if(xMove>0){
			 double blPoint=x+charBodyWidth+xMove;
			 int blockHR=manager.GetXYPointObject(blPoint,yyHead);
			 int blockFR=manager.GetXYPointObject(blPoint,y+charBodyHeight*.85);
				if(manager.CheckWallBlock(blockHR) > 0 || manager.CheckWallBlock(blockFR) > 0){
				 x=Math.Floor(blPoint/manager.BlockWidth)*manager.BlockWidth-charBodyWidth;
				 xMove*=xBounce;
				}
			}
			else 
			if(xMove<0){
			 double blPoint=x+xMove;
			 int blockHL = manager.GetXYPointObject(blPoint,yyHead);
			 int blockFL = manager.GetXYPointObject(blPoint,y+charBodyHeight*.85);
				if(manager.CheckWallBlock(blockHL) > 0 || manager.CheckWallBlock(blockFL) > 0){
				 x=Math.Floor(blPoint/manager.BlockWidth +1)*manager.BlockWidth;
				 xMove*=xBounce;
				}
			}
		 }
			x+=xMove;
			y+=yMove;

		//n`--------->



		// ̌ --

			if(myPad.X > 0)HFace=1;
			else if(myPad.X < 0)HFace=-1;
			  if(yMove < -9 ){ //㏸
				Face=imgSwimMove;
			  }else
			  if(yMove != 0){
				Face=imgSwim;
			  }
			  else {
				if(xMove * hFace < 0 )Face=imgBrake;
				else 
				if(Math.Abs(xMove)>0 )Face=imgWalk;
				else
				Face=imgStand;

				if(sitdown)Face=imgSit; // Ⴊł

			  }

			// t@CA[
			if(fire && (!sitdown || yMove!=0)){
			 if(myPad.ButtonB==1 && !fireFlag){
			  fireball.Call();fireFlag=true;
			 }
			 if(myPad.ButtonB==0)fireFlag=false;
			}

			 if(myPad.ButtonA==0)jumpFlag=false;


			if(innerTimer%30==0)
				manager.CreateEffect(CharCode.AwaEffect,x+charBodyWidth/2,y,0);



			if(x < manager.ScrollLeft){
				x=manager.ScrollLeft;
				if(xMove<0)xMove=0;
			}
			else
			if(x>manager.ScrollLeft+manager.VirtualWidth-charSpriteWidth){
//			if(x +charBodyWidth> manager.ScrollLeft + manager.VirtualWidth){
				x=manager.ScrollLeft + manager.VirtualWidth - charSpriteWidth;
				if(xMove>0)xMove=0;
			}

			if(y < manager.ScrollYmin)y=manager.ScrollYmin;
			else
			if(y > manager.ScrollYmax + manager.VirtualHeight+manager.BlockHeight){Drop();return false;}

		 return true;
		} // end actionSwim


//----------------------
		
		public override bool DrawEntry(){
			SetSize();
			sprite.MoveTo(x-cSprX,y-cSprY,z);
			fireball.DrawEntry();
			//if(ghost && (innerTimer%2==0))return false;
			return sprite.DrawEntry();
		}

//----------------------
		public override int GetBonus(int s){
			if(s >= GameConfig.BonusTable.Length){
				GetItem(ItemCode.Iget);
				manager.DBGn("+1GET+ "+life);
				return ItemCode.IgetNum;
			}else{
				if(s<0)s=0;
				GetScore(GameConfig.BonusTable[s]);
				return GameConfig.BonusTable[s];
			}
		}
//----------------------
		public override int GetKickBonus(){
			int b=GetBonus(kickBonus++);
			 if(b==ItemCode.IgetNum){
//				GetItem(ItemCode.Iget);
//				manager.CreateMessage("+1GET+",x,y);
			 }else{
				GetScore(b);
				manager.CreateEffect(CharCode.ScoreEffect,x,y,b);
			 }
			return score;
		}
//----------------------
		public override int GetStarBonus(){
			int b=GetBonus(starBonus++);
			 if(b==ItemCode.IgetNum){
//				GetItem(ItemCode.Iget);
				manager.CreateMessage("+1GET+",x,y);
			 }else{
				GetScore(b);
				manager.CreateEffect(CharCode.ScoreEffect,x,y,b);
			 }
			return b;
		}
//----------------------
		public override int GetScore(int s){
//			manager.DBGn("GetScore:"+score+"+"+s+" ="+(score+s));
			score+=s;
			return score;
		}
//----------------------
		public override int StepEnemy(MCharacter m){
			stepCnt=10000;
			if(++jumpBonus==1){
				GetScore(m.Score);
				manager.CreateEffect(CharCode.ScoreEffect,x,y,m.Score);
				return m.Score;
			}
			
			  int b=GetBonus(jumpBonus-2);
//				manager.DBGn(" score="+m.Score+" bonus="+b+" ID="+m.ID+" life="+life);
			 if(b==ItemCode.IgetNum){
//				GetItem(ItemCode.Iget);
				manager.CreateMessage("+1GET+",x,y);
			 }else{
//				GetScore(b);
				// {[iXƓ|G̃XRÁAق\
			 	if(b<m.Score)b=m.Score;
				manager.CreateEffect(CharCode.ScoreEffect,x,y,b);
			 }
			return b;
		}
		public void ResetJumpBonus(){
			jumpBonus=0;
		}
//----------------------
			
		public override void GetItem(int n){
		 try{
			int nx=n;
			switch(n){
				case CharCode.Coin:
				 nx=ItemCode.Coin;
				break;
				case CharCode.Kinoko:
				 nx=ItemCode.Kinoko;
				break;
				case CharCode.Flower:
				 nx=ItemCode.Flower;
				break;
				case CharCode.Star:
				 nx=ItemCode.Star;
				break;
				case CharCode.Iget:
				 nx=ItemCode.Iget;
				break;
				case CharCode.GoldenAxe:
				 nx=ItemCode.GoldenAxe;
				break;
				case CharCode.Poison:
				 nx=ItemCode.Poison;
				break;
/*
				case CharCode.DokanUp:
				 nx=ItemCode.DokanUp;
				break;
				case CharCode.DokanDown:
				 nx=ItemCode.DokanDown;
				break;
				case CharCode.DokanLeft:
				 nx=ItemCode.DokanLeft;
				break;
				case CharCode.DokanRight:
				 nx=ItemCode.DokanRight;
				break;
				case CharCode.TsutaUp:
				 nx=ItemCode.TsutaUp;
				break;
*/
			}
			switch(nx){
				case ItemCode.Coin:
				 coin++;
				 if(coin%100==0){
					life++;
					manager.CreateMessage("+1GET+",x,y);
					coin=0;
				 }
				break;
				case ItemCode.Kinoko:
					GetScore(1000);
					if(mode==PlayerMode.Normal)
							SetMode(PlayerMode.Super,true);
				break;
				case ItemCode.Flower:
					GetScore(2000);
					if(mode==PlayerMode.Normal)
							SetMode(PlayerMode.Super,true);
					else
					if(!fire)
							SetMode(PlayerMode.Fire,true);
					else{
							manager.CreateMessage("2000",x,y);
							fireball.Add();
					}
				break;
				case ItemCode.Star:
					GetScore(2000);
					SetMode(PlayerMode.Star,true);
				break;
				case ItemCode.Iget:
					life++;
//					manager.CreateMessage("+1GET+",x,y);
				break;
/*
				case ItemCode.GoldenAxe:
				break;
				case ItemCode.Poison:
				break;

				case ItemCode.DokanUp:
				break;
				case ItemCode.DokanDown:
				break;
				case ItemCode.DokanLeft:
				break;
				case ItemCode.DokanRight:
				break;
				case ItemCode.TsutaUp:
				break;
*/
			}
		 }catch(Exception e){
			manager.DBGn("Exception" + e + " in Player.GetItem");
		 }
		}



		public void SetMode(int m,bool flag){

		  if(flag){
			animateFlag=true;
			animateMode=m;
			animateCounter=0;
			return;
		  }

		  switch(m){
			case PlayerMode.Fire:
			 if(mode !=PlayerMode.Normal){
				fire=true;
				mode=PlayerMode.Fire;
			 }
			 goto case PlayerMode.Super;
			case PlayerMode.Super:
			 if(charBodyHeight!=charBigHeight){
				oldY=y-=(charBigHeight-charSmallHeight);
				charBodyHeight=charBigHeight;
				charSpriteHeight=charBigSpriteHeight;
				SetSize();
			 }
				if(mode==PlayerMode.Normal)mode=PlayerMode.Super;
			break;

			case PlayerMode.Ghost:
			 ghost=true;
			 ghostTimer=ghostTimerLength;
			 sprite.Opacity=.5;
			 goto case PlayerMode.Normal;

			case PlayerMode.Normal:
			 if(charBodyHeight!=charSmallHeight){
				oldY=y+=(charBigHeight-charSmallHeight);
				charBodyHeight=charSmallHeight;
				charSpriteHeight=charSmallSpriteHeight;
				SetSize();
				fire=false;
			 }
				sitdown=false;
				mode=PlayerMode.Normal;
				fireball.Reset();
			break;

			case PlayerMode.NGhost:
			 ghost=false;
			 ghostTimer=0;
			 sprite.Opacity=1;
			break;
			case PlayerMode.Star:
			 star=true;
			 starTimer=starTimerLength;
			 starBonus=0;
			break;
			case PlayerMode.NStar:
			 star=false;
			 starTimer=0;
			 starBonus=0;
			break;

			case PlayerMode.Die:		break;
			case PlayerMode.Drop:		break;
			case PlayerMode.Timeover:	break;
		  }
		} //

		public void SetAnimateMode(int anim){
			if(anim==0){animateFlag=false;return;}
			animateFlag=true;
			animateMode=anim;
			animateCounter=0;
		} //
		public void StopAnimate(){
			animateFlag=true;
			animateMode=0;
			animateCounter=1;
		} //

		public void SetAnimMaster(MCharacter m,int cnt){
			master=m;
			SetAnimateMode(PlayerMode.Pause);
		}




	
		public void Drop(){
			int r=evManager.EventDrop(this);
			if(r<0)SetMode(PlayerMode.Drop,true);
		}
	
		public void GoalFlag(){SetAnimateMode(PlayerMode.Goal);}

		public void CatchJumpBlock(JumpBlock m,double jump){

			y=m.Y+(m.Height-m.SpriteHeight)-charBodyHeight;
			if(myPad.ButtonA !=0 && jumpFlag != true){
				yMove=-jump;
				jumpFlag=true;
				stepCnt=5;
				m.ReleasePlayer();
			}else{
				jumpFlag=false;
			}
		}
		public void ReleaseJumpBlock(JumpBlock m){
			y=y-charBodyHeight;
			yMove=-18.1;
			jumpFlag=true;
			stepCnt=5;
		}

		public void CatchLift(MCharacter m){
			yMove=0;
			x+=m.XMove;
			y+=m.YMove;
			xCameraControl+=m.XMove;
			yCameraControl+=m.YMove;
			jumpBonus=0;
			if(myPad.ButtonA==0)jumpFlag=false;
		
		}


//----------------------

		public override int Damage(MCharacter m){
		 if(ghost || star)return 9;
		  if(mode==PlayerMode.Normal)
			{SetAnimateMode(PlayerMode.Die);PlayerDamage(0,m);return 0;}
		  else
			{SetMode(PlayerMode.Ghost,true);PlayerDamage(1,m);return 1;}
		} //

		public void Die(){Die(0);}
		public void Die(int flag){
			SetMode(PlayerMode.Normal,false);
			life--;
			animateFlag=false;
			ghost=false;
			sprite.Visible=true;
			throw new GameException(GameException.Die,0);
		} //

		public void Timeover(){
			SetMode(PlayerMode.Die,true);
		}
		
		public void DokanWarp(int wtype,int wID){
			int wt=PlayerMode.DokanDown;
			switch(wtype){
			case CharCode.DokanUp:
			 wt=PlayerMode.DokanUp;
			break;
			case CharCode.DokanDown:
			 wt=PlayerMode.DokanDown;
			break;
			case CharCode.DokanLeft:
			 wt=PlayerMode.DokanLeft;
			break;
			case CharCode.DokanRight:
			 wt=PlayerMode.DokanRight;
			break;
			case CharCode.TsutaUp:
			 wt=PlayerMode.TsutaUp;
			break;
			}
			//manager.warpID=warpID;
			warpID=wID;
			SetAnimateMode(wt);
		}
		public void Axe(){
			SetAnimateMode(PlayerMode.Axe);
		}


//----------------------

		public int SpecialAction(){
			innerTimer++;
			//Ⴊł痧
		  if(		(mode!=PlayerMode.Normal) && 
				sitdown 
				&& (animateMode!=PlayerMode.DokanDown)
			){
			charBodyHeight=charBigHeight;
			charSpriteHeight=charBigSpriteHeight;
			y-=(charBigHeight-charSmallHeight);
			SetSize();
			sitdown=false;
		  }
		  switch(animateMode){
			case PlayerMode.Fire:
			if(mode!=PlayerMode.Normal){
			  if(animateCounter==0)animateCounter=30;
			  animFire(30);
			  yMove=0;jumpFlag=false;
			}
			 break;
			case PlayerMode.Super:
			// manager.DBGn("animateCounter="+animateCounter);
			 if(animateCounter==0)animateCounter=30;
			 animKinoko(30);
			 yMove=0;jumpFlag=false;
			break;

			case PlayerMode.Ghost:
			 if(animateCounter==0)animateCounter=24;
			 sprite.Opacity=.5;
			 animDamage(24);
			 yMove=0;jumpFlag=false;
			break;

			case PlayerMode.Die:goto case PlayerMode.Drop;
			case PlayerMode.Drop:
			 if(animateCounter==0)animateCounter=80;
			 animDie(80);
			 if(animateCounter==1)Die();
			break;

			case PlayerMode.Goal:
			 if(animateCounter==0)animateCounter=-1;
			 animGoal(-1);
			break;
			case PlayerMode.Axe:
			 if(animateCounter==0)animateCounter=-1;
			 animAxe(-1);
			break;
			case PlayerMode.TimeBonus:
			 if(animateCounter==0)animateCounter=-1;
			 animGoalTimeBonus(-1);
			break;

			case PlayerMode.Saitama:
			 if(animateCounter==0)animateCounter=5000;
			 saitama_saitama_saitama(-1);
			break;


			case PlayerMode.Pause:
			 animateCounter=-1;
			 if(master!=null)master.Action();
			break;

			default:
			 if(	animateMode >= PlayerMode.DokanUp &&
				animateMode <= PlayerMode.TsutaUpOut){
			  if(animateCounter==0)animateCounter=24;
			  animDokan(24);
			 }
			 else{
			  animateCounter=1;
			 }
			break;
		  } // end switch


		  if(--animateCounter==0){
			SetMode(animateMode,false);
			animateFlag=false;
			animateMode=0;
		  }
		 return 1;
		} //
	
     //-----------
		private void animKinoko(int mcnt){
//			manager.DBGn("animKinoko"+animateCounter);
		 double p=((double)mcnt-animateCounter)/mcnt*(charBigSpriteHeight-charSmallSpriteHeight);
		  charSpriteHeight=(int)Math.Round(charSmallSpriteHeight+p);
		  SetSize();
		} //

     //-----------
		private void animFire(int mcnt){
		 string saitama="SAITAMA SAITAMA!";
		  switch(animateCounter){
			case 20:
			 saitama="SAITAMA  SAITAMA  SAITAMA!";
			break;
			case 10:
			 saitama="S A I T A M A !";
			break;
		  }
		  if(animateCounter%15==0){
			  MCharacter m= manager.CreateMessage(saitama,x,y);
			  m.Sprite.Color=Color.Red;
		  }
		} //
     //-----------
		private void animDamage(int mcnt){
			ghost=true;
		 double p=((double)mcnt-animateCounter)/mcnt*(charBigSpriteHeight-charSmallSpriteHeight);
		  charSpriteHeight=(int)Math.Round(charBigSpriteHeight-p);
		  SetSize();
		} //

     //-----------
		private void animDie(int mcnt){
		 int p=(mcnt-animateCounter);
			Face=imgDie;
		  if(y>manager.ScrollTop+manager.VirtualHeight)Visible=false;
		  if(animateCounter==mcnt){
		   if(y<manager.ScrollTop+manager.VirtualHeight)yMove=-22.5;// ]͒˂Ȃ
			   ghost=false;
		   }else
		   if(animateCounter <= mcnt-10){
			yMove += 2;
			y    += yMove;
		   }
		} //

     //-----------
		private void animGoal(int mcnt){
//			manager.DBGn("animateCounter="+animateCounter);
		  double flPoint = y+charBodyHeight+yMove;
		  int blockP  = manager.GetXYPointObject(x+charBodyWidth/2,y+charBodyHeight/2);
		  int blockF  = manager.GetXYPointObject(x+charBodyWidth/2,flPoint);
		  int blockFC = manager.CheckFloorBlock(blockF);
		  int blockLF  = manager.GetXYPointObject(x+8,y+charBodyHeight/2);

		  MCharacter F= manager.GetGoalFlagObject();//GOALFLAG; //@
		  double flPoint2 = F.Y+F.Height+yMove;
		  
		  int blockP2  = manager.GetXYPointObject(x+charBodyWidth/2,F.Y+F.Height/2);
		  int blockF2  = manager.GetXYPointObject(x+charBodyWidth/2,flPoint2);
		  int blockFC2 = manager.CheckFloorBlock(blockF2);
		
		
		  if(F.Mind == Mind.Dummy){
			blockFC2=blockFC;
		  }
		  
		  if(animateCounter>-10000){
			if(animateCounter==-1){
				//|[{[iX̎Zo()
				int[] table = GameConfig.FlagBonusTable;
				double fl=0;
				int flagBonus=5000;
				int i=0;
				for(fl=y+charBodyHeight;fl<manager.ScrollTop+manager.VirtualHeight;fl+=manager.BlockHeight){
					int b=manager.GetXYPointObject(x+charBodyWidth/2,fl);
					if(b!=Blocks.BarTop && b!=Blocks.Bar)break;
					i++;
				}
				 if(i<table.Length)flagBonus=table[i];
				x=Math.Floor((x+charBodyWidth/2)/manager.BlockWidth)*manager.BlockWidth-
										(charBodyWidth/3)+4;
				manager.CreateMessage(flagBonus.ToString(),x+manager.BlockWidth,y);

			}

			y+=10;yMove=0;
			if(F!=null)F.Y+=10;
			if(blockFC>0){
				y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
			}

			 Face=imgBar;
			 HFace=1;
			if(blockFC2 > 0){
				animateCounter=-10000;
				if(F!=null)F.Y=Math.Floor(flPoint2/manager.BlockHeight)*manager.BlockHeight-F.Height;
				Face=imgWalk;
				hFace=1;
			}
		  }else
		  if(animateCounter>-10010){
			if(animateCounter==-10001){
				x=Math.Floor(x/manager.BlockWidth+2)*manager.BlockWidth-(charBodyWidth/2)-6;
			}
			Face=imgBar;
			HFace=-1;
		  }else{
			Face=imgWalk;
			HFace=1;
			yMove+=yAccel;
			if(blockFC>0){
				y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
				yMove=0;
			}

			manager.ScrollLeft+=4;
			if(manager.ScrollLeft > manager.ScrollXmax)manager.ScrollLeft=manager.ScrollXmax;
			x+=4;

			y+=yMove;
//			if(blockP==Blocks.Goal || x>=manager.ScrollXmax+manager.VirtualWidth-charSpriteWidth){
			if(blockLF==Blocks.Goal || x>=manager.ScrollXmax+manager.VirtualWidth-charSpriteWidth){
				xMove=0;
				yMove=0;
				x=Math.Floor(x/manager.BlockWidth + 1)* manager.BlockWidth + 4;
				y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
				myPad.Reset();
				animateCounter=0;
				SetAnimateMode(PlayerMode.TimeBonus);
			}
		  }


		 if(F!=null)F.DrawEntry();
		} //


		private int clearTime=0;
		private void animGoalTimeBonus(int mcnt){
		  MCharacter F2=manager.GetCastleFlagObject();//new DummyObject(ENV);//GOALFLAG2;
		  if(animateCounter==-1){
			clearTime = manager.GameTimer ;
		  }

		  Face=imgStand;
		  Z=0;

		  if(manager.GameTimer > 0 ) {
				    GetScore(50);manager.GameTimer--;
				if(myPad.ButtonA != 0 || myPad.ButtonB != 0){
				    if(manager.GameTimer > 0 ) {GetScore(50);manager.GameTimer--;}
				    if(manager.GameTimer > 0 ) {GetScore(50);manager.GameTimer--;}
				    if(manager.GameTimer > 0 ) {GetScore(50);manager.GameTimer--;}
				    if(manager.GameTimer > 0 ) {GetScore(50);manager.GameTimer--;}
				}

		  }else
		  if(manager.GameTimer==0 && animateCounter<0){
			int hn=clearTime%10;
			if(hn==6 || hn==3 || hn==1)
				animateCounter=hn*15+15+30;
			else
				animateCounter=9+30;
			
		  }else
		  if( animateCounter > 1 + 30 ){
			if(animateCounter % 15==0){
			
				double xx=x+manager.M(manager.VirtualWidth*.6)-manager.VirtualWidth*.3-manager.BlockWidth;
				double yy=manager.VirtualHeight*.3+manager.M(manager.VirtualHeight*.2)-manager.VirtualHeight*.1+manager.ScrollTop;
				manager.CreateEffect(CharCode.HanabiEffect,xx,yy,0).YMove=-8;
			
				GetScore(500);
			}
			if(animateCounter <= 8+30){
				if(F2!=null)F2.Y+=F2.YMove;
			}
		  }else
		  if( animateCounter >  1 ){
//				manager.Mozaic+=2;
		  }else
		  if( animateCounter == 1 ){
		  }

		} //



		private void animDokan(int mcnt) {
		 int p=(mcnt-animateCounter)/mcnt;
		 double xm=0,ym=0;
		 double cpX=x+charBodyWidth/2,cpY=y+charBodyHeight/2;
		 bool outflag=true;
		 bool tsutaflag=false;

		 xCameraControl=0;yCameraControl=0;

		 switch(animateMode){
			case PlayerMode.TsutaUp:
			 outflag=false;
			 goto case PlayerMode.TsutaUpOut;
			case PlayerMode.TsutaUpOut:
			 ym=-yClimbSpeed;
			 Face=imgClimbMove;
			 climbFlag=true;
			 tsutaflag=true;
			break;

			case PlayerMode.DokanUp:
			 outflag=false;
			 ym=-2;
			break;
			case PlayerMode.DokanUpOut:
			 ym=-2;
			 Face=imgStand;
			 cpY=y+charBodyHeight-2;
			break;

			case PlayerMode.DokanDown:
			 outflag=false;
			 ym=2;
			break;
			case PlayerMode.DokanDownOut:
			 ym=2;
			 Face=imgStand;
			 cpY=y+2;
			break;


			case PlayerMode.DokanRight:
			 outflag=false;
			 xm=1;
			 goto case PlayerMode.DokanRightOut;
			case PlayerMode.DokanRightOut:
			 xm+=2;
			 Face=imgWalk;
			 cpX=x-2;
			break;

			case PlayerMode.DokanLeft:
			 outflag=false;
			 xm=-1;
			 goto case PlayerMode.DokanLeftOut;
			case PlayerMode.DokanLeftOut:
			 xm-=2;
			 Face=imgWalk;
			 hFace=-1;
			 cpX=x+charBodyWidth+2;
			break;
		 }
		
		 x+=xm;xMove=xm;
		 y+=ym;

			if(!tsutaflag){
				z=90;
			  if(outflag){
				int bp=manager.CheckWallBlock(manager.GetXYPointObject(cpX,cpY));
				if(bp>0){animateCounter=10;}
				else {animateCounter=1;}
			  }
			}

		 if(animateCounter==1){
			if(tsutaflag){
				Face=imgClimb;
				if(!outflag){
				 throw new GameException(GameException.Warp,warpID);
				}else{
				 xMove=5;
				 Face=imgJump;
				 climbFlag=false;
				 jumpFlag=true;
				}
			}
			else{
			if(outflag){
				Z=PlayerMode.playerZ;
			}else{ 
			  if(sitdown && mode!=PlayerMode.Normal){//Ⴊł痧
				charBodyHeight=charBigHeight;
				charSpriteHeight=charBigSpriteHeight;
				y-=(charBigHeight-charSmallHeight);
				SetSize();
				sitdown=false;
			  }
				throw new GameException(GameException.Warp,warpID);
			}
			}
		 }
		} //

		private void animAxe(int mcnt){
		  double flPoint = y+charBodyHeight+yMove;
		  int blockP   = manager.GetXYPointObject(x+charBodyWidth/2,y+charBodyHeight/2);
		  int blockF   = manager.GetXYPointObject(x+charBodyWidth/2,flPoint);
		  int blockFL  = manager.GetXYPointObject(x,flPoint);
		  int blockFR  = manager.GetXYPointObject(x+charBodyWidth,flPoint);
		  int blockFC  = manager.CheckFloorBlock(blockF);
		  if(animateCounter>0){
			return;
		  }
		  else
		  if(animateCounter>-10000){
			Face=imgWalk;HFace=1;
			yMove+=yAccel;
			if(yMove>ySpeedMax)yMove=ySpeedMax;
			xMove+=xAccel;
			if(xMove>xSpeedMaxTurbo)xMove=xSpeedMaxTurbo;
			
			if(manager.CheckFloorBlock(blockFL)>0 || manager.CheckFloorBlock(blockFR)>0){
				y=Math.Floor(flPoint/manager.BlockHeight)*manager.BlockHeight-charBodyHeight;
				yMove=0;
			}

			y+=yMove;
			x+=xMove;
			manager.ScrollLeft +=xMove *.8;

			if(blockP == Blocks.Goal || animateCounter < -1000|| y >manager.StageHeight){
				animateCounter=-10000;
				xMove=0;
				yMove=0;
			}
		  }else{
			Face=imgStand;HFace=1;

			manager.ScrollLeft+=6;

			if(x <= manager.ScrollLeft+manager.VirtualWidth/2 - manager.BlockWidth*2 || animateCounter < -12000){
				xMove=0;
				yMove=0;
				animateCounter=30*2;
				clearTime=manager.GameTimer;
				manager.GameTimer=0;
				evManager.EventPrincess(this);
			}else
			if(y>manager.StageHeight){
				throw new GameException(GameException.Goal,0);
			}
		  }


		}
		

	private int saitamacnt=0;
	private double saitamaTurbo=.1;
	private double saitamaAccel=.001;
	public void SetSaitama_saitama_saitama(){
		saitamacnt=0;saitamaTurbo=.1;saitamaAccel=.1;
		SetAnimateMode(PlayerMode.Saitama);
	}
	private void saitama_saitama_saitama(int mcnt){
		fireball.Unlimited=true;
		MCharacter boss=manager.GetBoss();
		if(boss==null){
			animateCounter=1;
			fireball.Unlimited=false;
			return;
		}

		if(saitamacnt==0){
		 xMove=0;
		 xCameraControl=.5;
		}
		boss.X+=hFace*.2;
//		xMove+=xAccel;
		xMove+=hFace*.1;
		x+=xMove;

		MCharacter shadow = manager.CreateEffect(CharCode.ShadowCharacterEffect,x,y,0);
		shadow.SetMaster(this);
		

		if(x+charBodyWidth>manager.ScrollLeft+manager.VirtualWidth){
			xMove=-5;
			x=manager.ScrollLeft+manager.VirtualWidth-charBodyWidth;
		}else
		if(x<manager.ScrollLeft){
			xMove= 5;
			x=manager.ScrollLeft;
		
		}

		if(yMove==0){
			yMove=-manager.M(28)+.1;
		}
		Face=imgJump;
		basicMove();

		HFace=(boss.X > x)?1:-1;

		if(saitamacnt==30){
		 manager.CenterMessage("ʕS",manager.VirtualHeight*.5,500).YMove=-1.3;
		}
		
		saitamaTurbo+=saitamaAccel;saitamaAccel+=.002;
		if(saitamaTurbo >= 1){
			saitamaTurbo-=1;
			saitamacnt++;
			fireball.Call();
		}
		fireball.Action();

		if(saitamacnt>=100){
			fireball.Unlimited=false;
			fireball.Kill();
			boss.YMove=-10;
			boss.XMove=10*hFace;
			boss.YAccel=1;
			boss.Kill(KillMode.Fire);
			manager.KillGoldenAxe();
			xMove=0;
			animateCounter = -1;
			animateMode=PlayerMode.Axe;
		}
		
	}

//----------------------







	}






















	class FireballGroup{
		private int maxFireballs=GameConfig.DefaultFireballs;
		private int maxFireballsMax  = GameConfig.MaxFireballs;
		private int defaultFireballs = GameConfig.DefaultFireballs;
		private MCharacter master;
		private ObjGroup enemy;
		 public ObjGroup Enemy{
			set{enemy=value;}
		 }
		private Fireball[] fire= new Fireball[GameConfig.MaxFireballs];
		private StageManager manager;
		private bool unlimited=false;
		 public bool Unlimited{
			set{
				if(unlimited != value){
					unlimited=value;
					if(!unlimited)Reset();
				}
			}
		 }
		public FireballGroup(MCharacter m,StageManager E){
			manager=E;
			master=m;
		
		  for(int i=0;i<maxFireballsMax;i++){
//			fire[i]=new Fireball(m,manager);
			fire[i]=new Fireball(manager,0,0);
			fire[i].SetMaster(m);
		  }
		}

		public MCharacter Call(){
			int ii=(unlimited)?maxFireballsMax:maxFireballs;
		  for(int i=0;i<ii;i++)
			if(!fire[i].Active){
				MCharacter f=fire[i].Call(enemy);
				if(unlimited)f.YMove=manager.M(2000)*0.01-10;
				return f;

			}
		  return null;
		}
		
		public bool DrawEntry(){
			int ii=(unlimited)?maxFireballsMax:maxFireballs;
		  for(int i=0;i<ii;i++)
			if(fire[i].Active)fire[i].DrawEntry();
			return true;
		}
		
		public bool Action(){
			int ii=(unlimited)?maxFireballsMax:maxFireballs;
		  for(int i=0;i<ii;i++)
			if(fire[i].Active)fire[i].Action();
			return true;
		}

		public bool Kill(){
		  for(int i=0;i<maxFireballsMax;i++)
			if(fire[i].Active)fire[i].Kill(0);
			return true;
		}
		
		public int SetMaxFireballs(int n){
			if(n>0 && n<maxFireballsMax)maxFireballs=n;
			return maxFireballs;
		}
		public int GetMaxFireballs(){
			return maxFireballs;
		}
		public int Add(){
			return SetMaxFireballs(maxFireballs+1);
		}
		
		public int Reset(){
			Kill();
			return SetMaxFireballs(defaultFireballs);
		}
	} //


	class Fireball :MCharacter{
		private bool active=false;
		private ObjGroup enemy;
		public bool Active{
			get{return active;}
		}

		public Fireball(StageManager m,double xx,double yy):
			base(m,xx,yy){
		}
		protected override void init(double xx,double yy,int option){
			xAccel=15;
			yAccel=2.5;
			yJump=11.7;
///			yAccel=3;
//			yJump=12.3;
			xMove=0;
			yMove=0;
			ySpeedMax=10;

			mind=Mind.Fire;

			charBodyWidth  = 16;
			charBodyHeight = 10;
			charSpriteWidth  = 16;
			charSpriteHeight = 16;

			verticalAlign=Valign.Middle;
			
			imgWalk=getImageID(PlayerMode.imgFireball);
			Face=imgWalk;
			Z=Zindex.BasicZ;
			SetSize();
		}

		public MCharacter Call(ObjGroup grp){
			MoveTo(master.X+master.Width/2,master.Y+master.Height/4);
			xMove=xAccel * master.HFace;
			 if(xMove==0)xMove=xAccel;
			x+=xMove;
			active=true;
			yMove=7;
			alive=1;
			Visible=true;
			enemy=grp;
			Face=imgWalk;
			DrawEntry();
			SetSize();
			return this;
		} //

		public override bool Action(){
		  if(!active)return false;
		  if(	(x > manager.ScrollLeft + manager.VirtualWidth) || 
			(x < manager.ScrollLeft) || 
			(y > manager.ScrollTop + manager.VirtualHeight)
		   ){Kill(0); return false;}

		   oldX=x;oldY=y;
		   ArrayList cc = enemy.GroupCollision(this);
		   if(cc.Count > 0){Kill(1);return false;}


		    yMove+=yAccel;
		    if(yMove > ySpeedMax)yMove=ySpeedMax;

//		    double blPoint=x+xMove+charBodyWidth/2;
		    double blPoint=x+charBodyWidth/2;

		    int blockP=manager.GetXYPointObject(blPoint,y+charBodyHeight*.5);
		    if(manager.CheckWallBlock(blockP)>0){Kill(1);return false;}

		    int blockH=manager.GetXYPointObject(blPoint,y-1);
//		    int blockH=manager.GetXYPointObject(blPoint,y+yMove);
		    int blockF=manager.GetXYPointObject(blPoint,y+charBodyHeight+yMove);
		    int blockF2=manager.GetXYPointObject(blPoint,y+manager.BlockHeight);
//		    int blockF=manager.GetXYPointObject(blPoint,y+charBodyHeight+1);
/*
		    if(yMove > 0 && manager.CheckFloorBlock(blockF)>0){
			y=Math.Floor(y/manager.BlockHeight+1) * manager.BlockHeight - charBodyHeight/2-1;
			yMove=-yJump;
		    }
*/
		    if(yMove > 0 && manager.CheckFloorBlock(blockF2)>0 && ((y+yMove) % manager.BlockHeight) > manager.BlockHeight-charBodyHeight){
			y=Math.Floor(y/manager.BlockHeight+1) * manager.BlockHeight - charBodyHeight/2-1;
			yMove=-yJump;
		    }
		    if(yMove < yAccel && manager.CheckUpperBlock(blockH)>0){
			y=Math.Floor((y-1)/manager.BlockHeight+1) * manager.BlockHeight;
			yMove=0.1;
		    }





		   x+=xMove;y+=yMove;
		   return true;
		} //

		public override int Kill(){return Kill(0);}
		public int Kill(int eflag){
			active=false;
			alive=-1;
			 if(eflag > 0)manager.CreateEffect(CharCode.HanabiEffect,x-8,y-8,0);
			 Visible=false;
			return -1;
		} //
		
		public override int GetScore(int n){
			manager.CreateMessage(""+n,x,y);
			return base.GetScore(n);
		}


	}
}