namespace mylib
{
	using System.Drawing;
	using System.Drawing.Drawing2D;
	using System.Drawing.Imaging;

	using System;
	using mylib;

#if MDX
	using Microsoft.DirectX;
	using Microsoft.DirectX.Direct3D;
	using DirectX=Microsoft.DirectX;
	using Direct3D=Microsoft.DirectX.Direct3D;
#endif


	public class Sprite{
		private double x=0;
		private double y=0;
		private double z=0;
		private double width=32;
		private double height=32;
		  public double Width{
			get{return width;}
		  }
		  public double Height{
			get{return height;}
		  }
		 private double drawWidth=32;
		 private double drawHeight=32;

		public double rotate=0;
		private bool flipV=false;
		private bool flipH=false;
		private double opacity=1;
		
		private bool visible=false;
		private int alive=-1;

		public int mode=0;// bitmap=0 text=1
			public const int BitmapMode=0;
			public const int TextMode=1;
			public const int RectMode=2;


		private string text;
		private string currentBitmapName;
		private int currentBitmapID=0;

		private Image face;
		
		private static ScreenManager manager;

		private int id=0;
		private static int idcnt=0;
		
		private static System.Drawing.Font defaultFont;
		private static Brush defaultBrush;
		private static Color defaultColor;

		private System.Drawing.Font  drawFont;
		private Brush drawBrush;
		private Color drawColor;

#if MDX
		private static Direct3D.Sprite dxSprite;
		 public static Direct3D.Sprite DxSprite{
			set{dxSprite=value;}
		 }
		private Rectangle sourceRect = new Rectangle(0,0,0,0);
		private Rectangle destRect   = new Rectangle(0,0,0,0);
//		private Point drawPoint      = new Point(0,0);
//		private DirectX.Matrix matrix	     = new DirectX.Matrix();

		private Vector3 center=new Vector3(0,0,0);
		private Vector3 pos = new Vector3(0,0,0);
		private DirectX.Matrix scaleMatrix = new DirectX.Matrix();
		private Point point = new Point(0,0);

		private int opa=255;// opacity
		private Direct3D.Font dxFont;
#else
		private ColorMatrix colorMatrix;
		private ImageAttributes imageAttributes;
		private Rectangle ocRect = new Rectangle();
#endif


//---------------------

		public Sprite(ScreenManager e,double xx,double yy){
			manager=e;
			alive=1;
			id=idcnt++;
			x=xx;
			y=yy;
		}
		public Sprite(){
			id=idcnt++;
			alive=1;
			x=0;y=0;z=0;
		}
		public Sprite(double xx,double yy,double zz){
			id=idcnt++;
			alive=1;
			x=xx;
			y=yy;
			z=zz;

		}
//---------------------

		public static ScreenManager Manager{
			set{
				manager=value;
				 if(defaultFont == null){
					defaultFont = new System.Drawing.Font("lr SVbN",(float)(manager.ScreenHeight/20),FontStyle.Bold);
					defaultColor=Color.White;
					defaultBrush=Brushes.White;
				 }
			}
		}

//---------------------

		public int ID{
			get{
				return id;
			}
		}

//---------------------
		public double X{
			set{
				x=value;
			}
			get{
				return x;
			}
		}

		public double Y{
			set{
				y=value;
			}
			get{
				return y;
			}
		}

		public double Z{
			set{
				z=value;
			}
			get{
				return z;
			}
		}
//---------------------

		public double Rotate{
			set{
				rotate=value;
			}
			get{
				return rotate;
			}
		}




		public double Opacity{
			set{
			   if(opacity!=value){
				opacity=value;
#if MDX
				opa= (int)Math.Round(255*opacity);
#else
				if(colorMatrix==null){
				 colorMatrix=new ColorMatrix();
				 colorMatrix.Matrix00 = 1;
				 colorMatrix.Matrix11 = 1;
				 colorMatrix.Matrix22 = 1;
				 colorMatrix.Matrix44 = 1;
				}
				 colorMatrix.Matrix33 = (float)value;
				 
				if(imageAttributes==null)imageAttributes= new ImageAttributes();
				imageAttributes.SetColorMatrix(colorMatrix);
#endif				
			   }
			}
			get{
				return opacity;
			}
		}

		public bool Visible{
			set {
				visible=value;
			}
			get {
				return visible;
			}
		}

		public bool FlipV{
			set {
				flipV=value;
			}
			get {
				return flipV;
			}
		}
/*
		public int FlipV{
			set {flipV=(value<0);}
		}
*/
		public bool FlipH{
			set {
				flipH=value;
			}
			get {
				return flipH;
			}
		}
/*
		public int FlipH{
			set {flipH=(value<0);}
		}
*/
//---------------------


		public int Alive{
			set {
				alive=value;
			}
			get {
				return Alive;
			}
		}

		public int Mode{
			get {
				return mode;
			}
		}

		public string Text{
			set{
				text=value;
				mode=TextMode;
			}
			get{
				return text;
			}
		}

		public static System.Drawing.Font DefaultFont{
			set{
				defaultFont=value;
			}
			get{
				return defaultFont;
			}
		}
		
		public static Color DefaultColor{
			set{
				defaultColor=value;
				defaultBrush = new SolidBrush(value);
			}
			get{
				return defaultColor;
			}
		}
		
		public static Brush DefaultBrush{
			set{
				defaultBrush=value;
			}
			get{
				return defaultBrush;
			}
		}

		
		public System.Drawing.Font Font{
			set{
				drawFont=value;
#if MDX
//				if(manager.DxDevice!=null)
					dxFont =
					new Direct3D.Font(manager.DxDevice,value);
#endif
			}
			get{
				return drawFont;
			}
		}
		
		public Color Color{
			set{
				drawColor=value;
//				if(drawColor==null)
//					drawBrush = null;
//				else
					drawBrush = new SolidBrush(value);
			}
			get{
				return drawColor;
			}
		}
		
		public Brush Brush{
			set{
				drawBrush=value;
			}
			get{
				return drawBrush;
			}
		}

//---------------------
		public int BitmapID{
			set{
//				if(currentBitmapID!=value)
					face = manager.GetImageData(value);
				currentBitmapName=manager.GetImageName(value);
				currentBitmapID=value;
				mode=BitmapMode;
			}
			get{
				return currentBitmapID;
			}
		}

		public string BitmapImageName{
			set{
				currentBitmapID=manager.GetImageID(value);
				face = manager.GetImageData(currentBitmapID);
				currentBitmapName=value;
				mode=BitmapMode;
			}
			get{
				return currentBitmapName;
			}
		}

		public Image Face{
			set{
				//currentBitmapID=manager.GetImageID(value);
				face = value;
				//currentBitmapName="unknown";
				mode=BitmapMode;
			}
			get{
				return face;
			}
		}


//---------------------


		public void SetSize(){
			drawWidth =width  * manager.DrawX;
			drawHeight=height * manager.DrawY;
		}
		public void SetSize(double ww,double hh){
			if(ww>=0)width=ww;
			if(hh>=0)height=hh;
			drawWidth =width  * manager.DrawX;
			drawHeight=height * manager.DrawY;
		}

//---------------------

		
		public void MoveTo(double xx,double yy,double zz){
			x=xx;
			y=yy;
			z=zz;
		}
		public void MoveTo(double xx,double yy){
			MoveTo(xx,yy,z);
		}

//---------------------

		
		public bool DrawEntry(){
			return manager.DrawEntry(this);
	//		return true;
		}


		public int Draw(Graphics g){
		 if(!visible)return -1;
		  if(alive<0)return -1;

		 double xp = (x-manager.ScrollLeft);
		 double yp = (y-manager.ScrollTop );
		 double xx = xp * manager.DrawX;
		 double yy = yp * manager.DrawY;
		 double ww=drawWidth; 
		 double hh=drawHeight;

			if(mode==TextMode){
				 System.Drawing.Font  tmpFont  = (drawFont  != null)?(drawFont ) : (defaultFont);
#if MDX
				 Color tmpColor = (drawBrush != null)?(drawColor) :(defaultColor);
				 if(dxFont==null)dxFont = 
					new Direct3D.Font(manager.DxDevice,defaultFont);
				 point.X=(int)Math.Round(xx);
				 point.Y=(int)Math.Round(yy);
				 scaleMatrix.Scale(1.0f,1.0f,0f);
				 dxSprite.Transform=scaleMatrix;
//				 dxSprite.Begin(SpriteFlags.AlphaBlend);
				dxFont.DrawText(
					dxSprite,
					text,
					point,
					tmpColor);
//				 dxSprite.End();
//				destRect.Width=(int)Math.Round(g.MeasureString(text,tmpFont).Width);
//				destRect.Height=tmpFont.Height;
#else
				 Brush tmpBrush = (drawBrush != null)?(drawBrush) :(defaultBrush);
				g.DrawString(text,tmpFont,tmpBrush,(float)xx,(float)yy);
#endif
			}

			else
			if(mode==RectMode){
				 Brush tmpBrush = (drawBrush != null)?(drawBrush) :(defaultBrush);
				g.FillRectangle(tmpBrush,(float)xx,(float)yy,(float)ww,(float)hh);
			}
			else
			 if(mode==BitmapMode){
#if MDX
// 悭킩ĂȂBBB
//				double xr=((width*manager.DrawX)/face.Width);
				double xr=ww/face.Width;
				double yr=hh/face.Height;
				 sourceRect.Width  = (int)face.Width;
				 sourceRect.Height = (int)face.Height;

				 pos.X=(float)(xx/xr);
				 pos.Y=(float)(yy/yr);
				 pos.Z=(float)(z/1000);

			scaleMatrix.Scale((float)xr,(float)yr,1.0f);
				 if(flipH){
					scaleMatrix.M11*=-1;
					pos.X=(float)(-pos.X-face.Width);
				 }
				 if(flipV){
					scaleMatrix.M22*=-1;
					pos.Y=(float)(-pos.Y-face.Height);
				 }
				dxSprite.Transform = scaleMatrix;
//				 dxSprite.Begin(SpriteFlags.AlphaBlend);
				dxSprite.Draw(
					manager.GetTextureData(currentBitmapID),
					sourceRect,
					center,
					pos,
				      Color.FromArgb(opa,255,255,255)
				      );
//				 dxSprite.End();
					
				
/*
			 destRect.Width    = (int)Math.Round(width*manager.DrawX);
			 destRect.Height   = (int)Math.Round(height*manager.DrawY);
			 drawPoint.X   = (int)Math.Round(xx*face.Width/ww);
//			 drawPoint.Y   = (int)Math.Round(yy*(face.Height/(height*manager.DrawY)));
			 drawPoint.Y   = (int)Math.Round(yy*(face.Height/hh));
				 if(flipH){
					drawPoint.X=-drawPoint.X-face.Width;
					destRect.Width*=-1;
				 }
				 if(flipV){
					drawPoint.Y=-drawPoint.Y-destRect.Height;
					destRect.Height*=-1;
				 }
				 dxSprite.Draw2D(
					manager.GetTextureData(currentBitmapID),
					sourceRect,
					destRect,
					drawPoint, 
				      Color.FromArgb(opa,255,255,255));
//*/
#else
				if(face!=null){
				  if(flipH){xx+=ww;ww*=-1;}
				  if(flipV){yy+=hh;hh*=-1;}
					if(opacity>=1)
					  g.DrawImage(face,
						(int)Math.Round(xx),
						(int)Math.Round(yy),
						(int)Math.Ceiling(ww),
						(int)Math.Ceiling(hh)
					  );
					else{
					ocRect.X =	(int)Math.Round(xx);
					ocRect.Y =	(int)Math.Round(yy);
					ocRect.Width =	(int)Math.Ceiling(ww);
					ocRect.Height=	(int)Math.Ceiling(hh);
					  g.DrawImage(face,
						ocRect,
						0,0,
						face.Width,face.Height,
						GraphicsUnit.Pixel,
						imageAttributes
					  );
					}
				}
#endif
			}
			return 1;
		}

		public int Kill(){
			visible=false;
			face=null;
			text=null;
			currentBitmapName=null;
			drawFont=null;
			drawBrush=null;
			System.GC.Collect();
#if MDX
		 if(dxFont!=null){
			dxFont.Dispose();
			dxFont=null;
		 }

#endif
			return -1;
		}

 }
}