namespace mylib{
	using System.Drawing;
	using System;
	using mylib;
#if MDX
	using System.Drawing.Imaging;
	using Microsoft.DirectX;
	using Microsoft.DirectX.Direct3D;
	using DirectX=Microsoft.DirectX;
	using Direct3D=Microsoft.DirectX.Direct3D;
#endif

	class WaitScreen{
		private EnvManager manager;
		private int innerTimer =0;
		private int mode=0;
		private int nextMode=0;
		
		public const int Logo     =  1;
		public const int Info     =  2;
		public const int Gameover =  3;
		public const int Title    =100;

		private int waitTimer =  0;
		private int     mozaic = 30;
		 public int Mozaic{
			get{return mozaic;}
		 }

		private System.Drawing.Font infoFont;
		private System.Drawing.Font logoFont;

#if MDX
		private Direct3D.Font dxInfoFont;
		private Direct3D.Font dxLogoFont;
#endif


		public WaitScreen(EnvManager E){
			manager=E;
			nextMode=EnvManager.Gaming;
			
		}
		private void initFont(){
			double w=manager.ScreenWidth;
			double h=manager.ScreenHeight;
			infoFont=new System.Drawing.Font("lr SVbN",(float)h/20,FontStyle.Bold);
			logoFont=new System.Drawing.Font("lr SVbN",(float)h/15,FontStyle.Bold);
#if MDX
			dxInfoFont=new Direct3D.Font(manager.DxDevice,infoFont);
			dxLogoFont=new Direct3D.Font(manager.DxDevice,logoFont);
#endif
		}


		public int Action(){
			int flg=0;
			innerTimer++;
			waitTimer--;
		  switch(mode){
			case Logo:
			 flg=actLogo();
			break;
			case Info:
			 flg=actInfo();
			break;
			case Gameover:
			 flg=actGameover();
			break;
			default:
			return EnvManager.Gaming;
		  }

		if(flg!=0){
		  return nextMode;
		}
		if(waitTimer<=0){
			return nextMode;
		}

		  return manager.Mode;
		}

		public void Draw(Graphics g){

		  switch(mode){
			case Logo:
			 drawLogo(g);
			break;
			case Info:
			 drawInfo(g);
			break;
			case Gameover:
			 drawGameover(g);
			break;
		  }
			
		}

//-------------------------------------

		public void SetLogoMode(Graphics g,int tm){
		  if(infoFont==null)initFont();
		  manager.ClsFlag=true;
			manager.GetGamePad().Reset();
			mode=Logo;
			manager.Mode  = EnvManager.Waiting;
			waitTimer = tm;
			mozaic    = 0;
			nextMode  = EnvManager.Title;
#if MDX
			mozaic=50;
#endif

		}

		private int actLogo(){
			if( padCheck() ){mozaic=0;return 1;}
			return 0;
		}
		private int drawLogo(Graphics g){
#if MDX
			  manager.DxDevice.Clear(ClearFlags.Target, Color.White, 1.0f, 0);
#else
			  g.Clear(Color.White);
#endif
			if(mozaic>0)mozaic--;


			 string str="X[p[}[[h()";
			 float h=logoFont.Height;
			 float w=g.MeasureString(str,logoFont).Width;
#if MDX
			 drawText(str,(manager.ScreenWidth-w)/2,(manager.ScreenHeight-h)/2,Color.Blue,dxLogoFont);
#else
			 g.DrawString(str,logoFont,Brushes.Blue,(float)(manager.ScreenWidth-w)/2,(float)(manager.ScreenHeight-h)/2);
#endif

	/*
			 string str2="ŏ̓ǂݍ݂ɏXԂ܂";
	//		 g.setColor(Color.black);
	//		 g.setFont(infoFont);
			 float h2=infoFont.Height;
			 float w=g.MeasureString(str,infoFont).Width;
			 g.DrawString(str,infoFont,Brushes.Black,(float)(manager.ScreenWidth-w)/2,(manager.ScreenHeight+h2)/2+h*1.5);
	*/

			return 0;
		}

//-------------------
		public void SetInfoMode(Graphics g,int tm){
		  if(infoFont==null)initFont();
		  manager.ClsFlag=true;
			manager.GetGamePad().Reset();
			mode=Info;
			manager.Mode  = EnvManager.Waiting;
			waitTimer = tm;
			mozaic    = 30;
			nextMode=EnvManager.Gaming;
		}//


		private int actInfo(){
			moz(30);
			if( padCheck() ){mozaic=30;return 1;}
			return 0;
		}

		private int drawInfo(Graphics g){
#if MDX
			  manager.DxDevice.Clear(ClearFlags.Target, Color.Black, 1.0f, 0);
#else
			  g.Clear(Color.Black);
#endif

			  Player P=manager.GetPlayerObject();

			 string str1="WORLD " + manager.GetWorldNumber()+ " - " + manager.GetAreaNumber();
			 float h=infoFont.Height;
			 float w=g.MeasureString(str1,infoFont).Width;
#if MDX
			 drawText(str1,	((manager.ScreenWidth  -  w) / 2),
			 		(manager.ScreenHeight * .4)    ,
			 		Color.White,dxInfoFont);
#else
			 g.DrawString(str1,infoFont,Brushes.White,
			 		(float)((manager.ScreenWidth  -  w) / 2),
			 		(float)(manager.ScreenHeight * .4)    );
#endif





			 string life=( (P.Life > 15 ) ? "l吙": (""+P.Life) );
			 string str2="   x   " + life;
			 float w2=g.MeasureString(str2,infoFont).Width;
#if MDX
			 drawText(str2,	((manager.ScreenWidth  -  w) / 2 + w - w2),
			 		(manager.ScreenHeight * .6 + h / 2 ),
			 		Color.White,dxInfoFont);
			 int pid     = manager.GetImageID(PlayerMode.imgStand);
			 drawImage(pid,
				((manager.ScreenWidth - w) / 2 ),
				( manager.ScreenHeight * .6+ P.SpriteHeight * manager.DrawY * .5),
				(P.SpriteWidth  * manager.DrawX),
				(P.SpriteHeight * manager.DrawY)
			 );
#else
			 g.DrawString(str2,infoFont,Brushes.White,
			 			(float)((manager.ScreenWidth  -  w) / 2 + w - w2),
						(float)(manager.ScreenHeight * .6 + h / 2 )
			 );

			 g.DrawImage(manager.GetImageData(manager.GetImageID(PlayerMode.imgStand)),
					(float)((manager.ScreenWidth - w) / 2 ),
					(float)( manager.ScreenHeight * .6+ P.SpriteHeight * manager.DrawY * .5),
					(float)(P.SpriteWidth  * manager.DrawX),
					(float)(P.SpriteHeight * manager.DrawY)
			 );
#endif







			string str3="NOW LOADING...";
			 float w3=g.MeasureString(str3,infoFont).Width;
#if MDX
			 drawText(str3,
			 		manager.ScreenWidth-w3,
			 		manager.ScreenHeight-h,
			 		Color.White,dxInfoFont);
#else
			 g.DrawString(str3,infoFont,Brushes.White,
			 		(float)manager.ScreenWidth-w3,
			 		(float)manager.ScreenHeight-h);
#endif



			 string str4=manager.GameStage.InfoText1;
			 float w4=g.MeasureString(str4,infoFont).Width;
#if MDX
			 drawText(str4,
			 		((manager.ScreenWidth-w4)/2),
			 		( manager.ScreenHeight*.2),
			 		Color.Cyan,dxInfoFont);
#else
			 g.DrawString(str4,infoFont,Brushes.Cyan,
			 		(float)((manager.ScreenWidth-w4)/2),
			 		(float)( manager.ScreenHeight*.2));
#endif

			 string str5=manager.GameStage.InfoText2;
			 float w5=g.MeasureString(str5,infoFont).Width;

#if MDX
			 drawText(str5,
			 		(manager.ScreenWidth-w5)/2,
			 		( manager.ScreenHeight*.8),
			 		Color.Cyan,dxInfoFont);
#else
			 g.DrawString(str5,infoFont,Brushes.Cyan,
			 		(float)(manager.ScreenWidth-w5)/2,
			 		(float)( manager.ScreenHeight*.8));
#endif

			return 0;
		}
		

//-------------------
		private int gameoverFlag=0;
		public void SetGameoverMode(Graphics g,int tm,int flag){
			  if(infoFont==null)initFont();
			  gameoverFlag=flag;

			  manager.ClsFlag=true;
			  //----
				manager.GetGamePad().Reset();
				mode=Gameover;
				manager.Mode  = EnvManager.Waiting;
				waitTimer = tm;
				mozaic    = 5;
				nextMode=EnvManager.Title;
			}

		private int actGameover(){
			moz(30);
			if( padCheck() ){
				manager.ClsFlag=true;
				mozaic=30;
				return 1;}
			return 0;
		}
		private int drawGameover(Graphics g){
#if MDX
			  if(gameoverFlag==1)
				manager.DxDevice.Clear(ClearFlags.Target, Color.Blue, 1.0f, 0);
			  else	manager.DxDevice.Clear(ClearFlags.Target, Color.Red, 1.0f, 0);
#else
			  if(gameoverFlag==1)	g.Clear(Color.Blue);
			  else			g.Clear(Color.Red);
#endif

			  Player P=manager.GetPlayerObject();


			 string str1="  *  G A M E    O V E R  *  ";
			 float h=infoFont.Height;
			 float w=g.MeasureString(str1,infoFont).Width;
#if MDX
			 drawText(str1,
			 		((manager.ScreenWidth-w)/2),
			 		(manager.ScreenHeight*.4),
			 		Color.White,dxInfoFont);
#else
			 g.DrawString(str1,infoFont,Brushes.White,
			 		(float)((manager.ScreenWidth-w)/2),
			 		(float)(manager.ScreenHeight*.4));
#endif


			 string str2=""+P.Score;
			 float w2=g.MeasureString(str2,infoFont).Width;
#if MDX
			 drawText("SCORE",
						((manager.ScreenWidth   - w)/2),
						( manager.ScreenHeight * .6),
				 		Color.White,dxInfoFont);
			 drawText(str2,
						((manager.ScreenWidth   - w)/2+w-w2),
						( manager.ScreenHeight * .6),
				 		Color.White,dxInfoFont);
#else
			 g.DrawString("SCORE",infoFont,Brushes.White,
						(float)((manager.ScreenWidth   - w)/2),
						(float)( manager.ScreenHeight * .6));
			 g.DrawString(str2,infoFont,Brushes.White,
						(float)((manager.ScreenWidth   - w)/2+w-w2),
						(float)(manager.ScreenHeight * .6));
#endif



			 string str3=""+manager.HiScore;
			 float w3=g.MeasureString(str3,infoFont).Width;
#if MDX
			 drawText("HI SCORE",
			 			((manager.ScreenWidth-w)/2),
						( manager.ScreenHeight*.6+h*2),
				 		Color.White,dxInfoFont);
			 drawText(str3,
			 			((manager.ScreenWidth-w)/2+w-w3),
						( manager.ScreenHeight*.6+h*2),
				 		Color.White,dxInfoFont);
#else
			 g.DrawString("HI SCORE",infoFont,Brushes.White,
			 			(float)((manager.ScreenWidth-w)/2),
						(float)( manager.ScreenHeight*.6+h*2));
			 g.DrawString(str3,infoFont,Brushes.White,
			 			(float)((manager.ScreenWidth-w)/2+w-w3),
						(float)( manager.ScreenHeight*.6+h*2));
#endif

			return 0;
		}





//-------------------
//-------------------
		private void moz(int m){
			if(waitTimer<m)mozaic=(m-waitTimer);
			else if(mozaic>0)mozaic-=2;
		}

		private bool padCheck(){
			GamePad pad=manager.GetGamePad();
			if( pad.ButtonA !=0 || pad.ButtonB !=0)return true;
			else return false;
		}


#if MDX
		private Point point = new Point(0,0);
		private int r(double b){
				return (int)Math.Round(b);
		}
		private void setP(double x,double y){
			point.X=r(x);
			point.Y=r(y);
		}
		private void drawText(string str,double x,double y,Color col,Direct3D.Font dxFont){
			setP(x,y);
			dxFont.DrawText(manager.DxSprite,str,point,col);
		}
		
	// Ȃʓ|	
		private Rectangle srcRect = new Rectangle();
		private Microsoft.DirectX.Matrix scaleMatrix = new Microsoft.DirectX.Matrix();
		private Vector3 center = new Vector3();
		private Vector3 pos = new Vector3();
		private void drawImage(int imageID,double x,double y,double w,double h){
			 Image im   = manager.GetImageData(imageID);
			 Texture tx = manager.GetTextureData(imageID);

			double xr=w/im.Width;
			double yr=h/im.Height;

			srcRect.Width=im.Width;
			srcRect.Height=im.Height;
			pos.X=(int)Math.Round(x/xr);
			pos.Y=(int)Math.Round(y/yr);
			pos.Z=1;
			
			scaleMatrix.Scale(
					(float)(xr),
					(float)(yr),
					0f);
			manager.DxSprite.Transform= scaleMatrix;

			manager.DxSprite.Draw(
					tx,
					srcRect,
					center,
					pos,
					Color.FromArgb(255,255,255,255)
			);

			scaleMatrix.Scale(1.0f,1.0f,0f);
			manager.DxSprite.Transform= scaleMatrix;
		}
//*/
#endif

	}


}