namespace mylib
{
	using System;
	using System.Drawing;
	using mylib;


	public class ZSorter{
		private Sprite[] sortBuffer;
		private bool sorted=false;

		private int cnt=0;
		private int max=1024;

		public ZSorter(){
			sortBuffer = new Sprite[SystemConfig.MaxSprites+100];
			max=SystemConfig.MaxSprites;
		}


		public bool Entry(Sprite s){
			if(cnt>max)return false;
			sortBuffer[cnt++]=s;
			sorted=false;
			return true;
		}

		public void Sort(){
			int i,j;
			Sprite tmp;
			 for(i=0;i<cnt;i++){
			  for(j=cnt-1;j>i;j--){
				if(sortBuffer[j].Z > sortBuffer[j-1].Z){
					tmp		= sortBuffer[j];
					sortBuffer[j]   = sortBuffer[j-1];
					sortBuffer[j-1] = tmp;
				}
			  }
			 }
			sorted=true;
		}

		public void Flush(){
			for(int i=0;i<cnt;i++){
				sortBuffer[i]=null;
			}
			sorted=false;
			cnt=0;
		}

		public void Draw(Graphics g,double from ,double to){
			Draw(g,from,to,false);
		}
		public void Draw(Graphics g,double from ,double to,bool clflag){
			int i;
			if(!sorted)Sort();
			for(i=cnt-1;i>=0;i--){
			  if(sortBuffer[i].Z < from)continue;
			  if(sortBuffer[i].Z > to)break;
			  sortBuffer[i].Draw(g);
			}

			if(clflag)Flush();
		}


	}

}